# Reusable Components Library for React Typescript with styled-components.

## Usage
Install the package
```
npm install gws-components-library
```

Import the required component and start using it as a normal component.

```
import { TestComponent } from 'gws-components-library
```

## Documentation

### Core Components
- [Button Component](./documentation/Button.MD)
- [Input Component](./documentation//Input.MD)
- [Icon Component](./documentation//Icon.MD)
- [Icon Button Component](./documentation/IconButton.MD)
- [Dropdown Component](./documentation/Dropdown.MD)
- [Date Picker Component](./documentation/DatePicker.MD)
- [Color Picker Component](./documentation/ColorPicker.MD)
- [Dialog Alert Component](./documentation/DialogAlert.MD)
- [Dialog Select Component](./documentation/DialogSelect.MD)
- [Notification Component](./documentation/Notification.MD)

### Layout Components
- [Card Component](./documentation//Card.MD)
- [List Component](./documentation/List.MD)
- [Image Slider Component](./documentation//BasicImageSlider.MD)
- [Modal Component](./documentation/Modal.MD)
- [Multi Stepper Component](./documentation/MultiStepper.MD)
- [Table Component](./documentation/Table.MD)

### Security Components
- [Captcha](./documentation/Captcha.MD)
