"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BasicImageSlider = void 0;
const core_1 = require("@material-ui/core");
const icons_1 = require("@material-ui/icons");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const defaultLayouts_1 = require("../../constants/defaultLayouts");
const styles_1 = require("./styles");
const BasicImageSlider = ({ images, showCaption = false, className = defaultLayouts_1.DEFAULT_CLASSNAME, buttonHeight = defaultLayouts_1.DEFAULT_HEIGHT, buttonBorderRadius = defaultLayouts_1.DEFAULT_BORDER_RADIUS, containerWidth = defaultLayouts_1.DEFAULT_WIDTH, containerHeight = defaultLayouts_1.DEFAULT_HEIGHT, imgWidth = defaultLayouts_1.DEFAULT_HEIGHT, imgHeight = defaultLayouts_1.DEFAULT_HEIGHT, interval = defaultLayouts_1.DEFAULT_INTERVAL, }) => {
    var _a;
    const [activeIndex, setActiveIndex] = (0, react_1.useState)(0);
    const classes = (0, styles_1.useBasicImageSliderStyles)({
        buttonHeight,
        buttonBorderRadius,
        containerWidth,
        containerHeight,
        imgWidth,
        imgHeight,
    });
    const handleNext = (0, react_1.useCallback)(() => {
        setActiveIndex((prevIndex) => (prevIndex + 1) % images.length);
    }, [setActiveIndex, images.length]);
    const handlePrevious = () => {
        setActiveIndex((prevIndex) => (prevIndex + images.length - 1) % images.length);
    };
    (0, react_1.useEffect)(() => {
        if (interval === 0) {
            return;
        }
        const intervalId = setInterval(handleNext, interval);
        return () => clearInterval(intervalId);
    }, [interval, handleNext]);
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)(classes.basicImageSliderContainer, className) },
        react_1.default.createElement(core_1.Paper, { className: classes.paper },
            react_1.default.createElement("img", { className: classes.imageContainer, src: images[activeIndex].url, alt: images[activeIndex].alt }),
            react_1.default.createElement("div", { className: (0, classnames_1.default)(classes.buttonContainer, classes.buttonLeft) },
                react_1.default.createElement(core_1.IconButton, { className: classes.iconButton, onClick: handlePrevious },
                    react_1.default.createElement(icons_1.KeyboardArrowLeft, null))),
            react_1.default.createElement("div", { className: (0, classnames_1.default)(classes.buttonContainer, classes.buttonRight) },
                react_1.default.createElement(core_1.IconButton, { className: classes.iconButton, onClick: handleNext },
                    react_1.default.createElement(icons_1.KeyboardArrowRight, null))),
            showCaption && ((_a = images[activeIndex]) === null || _a === void 0 ? void 0 : _a.caption) ? (react_1.default.createElement(core_1.Typography, { variant: "h6", className: classes.caption }, images[activeIndex].caption)) : null)));
};
exports.BasicImageSlider = BasicImageSlider;
//# sourceMappingURL=BasicImageSlider.js.map