"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBasicImageSliderStyles = void 0;
const styles_1 = require("@material-ui/core/styles");
exports.useBasicImageSliderStyles = (0, styles_1.makeStyles)((theme) => (0, styles_1.createStyles)({
    basicImageSliderContainer: ({ containerWidth, containerHeight }) => ({
        display: "flex",
        alignItems: "center",
        justifyContent: "center",
        position: "relative",
        height: containerHeight,
        width: containerWidth,
        backgroundColor: theme.palette.background.default,
        padding: theme.spacing(2),
    }),
    paper: {
        display: "flex",
        flexDirection: "column",
        alignItems: "center",
        padding: theme.spacing(2),
    },
    imageContainer: ({ imgWidth, imgHeight }) => ({
        display: "flex",
        alignItems: "center",
        justifyContent: "center",
        marginBottom: theme.spacing(2),
        width: imgWidth,
        height: imgHeight,
        objectfit: "cover",
        overflow: "hidden",
        backgroundRepeat: "no-repeat",
        backgroundPosition: "center",
        backgroundSize: "cover",
    }),
    buttonContainer: ({ buttonHeight }) => ({
        height: buttonHeight,
        display: "flex",
        position: "absolute",
        top: "50%",
        transform: "translateY(-50%)",
        "& > *": {
            margin: theme.spacing(1),
        },
    }),
    iconButton: ({ buttonBorderRadius }) => ({
        borderRadius: buttonBorderRadius,
        "&:hover": {
            color: "black",
        },
    }),
    buttonLeft: {
        left: 0,
    },
    buttonRight: {
        right: 0,
    },
    caption: {
        textAlign: "center",
    },
}));
//# sourceMappingURL=styles.js.map