"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatePicker = void 0;
const date_fns_1 = __importDefault(require("@date-io/date-fns"));
const pickers_1 = require("@material-ui/pickers");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importDefault(require("react"));
const colors_1 = require("../../constants/colors");
const styles_1 = require("./styles");
const types_1 = require("./types");
const DatePicker = ({ className, id, name, value = null, type = types_1.DatePickerTypes.DATE_PICKER, width, height, maxWidth = colors_1.AUTO, maxHeight = colors_1.AUTO, padding, margin, backgroundColor, format, labelText, disabled = false, disablePast = false, onChange, onFocus, onBlur, }) => {
    const classes = (0, styles_1.useStyle)({
        width,
        height,
        maxHeight,
        maxWidth,
        padding,
        margin,
        backgroundColor,
    });
    switch (type) {
        case types_1.DatePickerTypes.DATE_PICKER:
            return (react_1.default.createElement(pickers_1.MuiPickersUtilsProvider, { utils: date_fns_1.default },
                react_1.default.createElement(pickers_1.DatePicker, { className: (0, classnames_1.default)(classes.root, className), id: id, name: name, value: value, format: format, onChange: onChange, onFocus: onFocus, onBlur: onBlur, label: labelText, disablePast: disablePast, disabled: disabled })));
        case types_1.DatePickerTypes.TIME_PICKER:
            return (react_1.default.createElement(pickers_1.MuiPickersUtilsProvider, { utils: date_fns_1.default },
                react_1.default.createElement(pickers_1.TimePicker, { className: (0, classnames_1.default)(classes.root, className), id: id, name: name, value: value, format: format, onChange: onChange, onFocus: onFocus, onBlur: onBlur, label: labelText, disabled: disabled })));
        case types_1.DatePickerTypes.DATE_TIME_PICKER:
            return (react_1.default.createElement(pickers_1.MuiPickersUtilsProvider, { utils: date_fns_1.default },
                react_1.default.createElement(pickers_1.DateTimePicker, { className: (0, classnames_1.default)(classes.root, className), id: id, name: name, value: value, format: format, onChange: onChange, onFocus: onFocus, onBlur: onBlur, label: labelText, disablePast: disablePast, disabled: disabled })));
        default:
            return null;
    }
};
exports.DatePicker = DatePicker;
//# sourceMappingURL=DatePicker.js.map