"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DialogSelect = void 0;
const core_1 = require("@material-ui/core");
const ArrowDropDown_1 = __importDefault(require("@material-ui/icons/ArrowDropDown"));
const Close_1 = __importDefault(require("@material-ui/icons/Close"));
const Error_1 = __importDefault(require("@material-ui/icons/Error"));
const List_1 = __importDefault(require("@material-ui/icons/List"));
const Search_1 = __importDefault(require("@material-ui/icons/Search"));
const classnames_1 = __importDefault(require("classnames"));
const lodash_1 = require("lodash");
const react_1 = __importStar(require("react"));
const react_infinite_scroll_component_1 = __importDefault(require("react-infinite-scroll-component"));
const styles_1 = require("./styles");
const START_PAGE = 1;
const getDefaultInputElement = ({ onOpen, value, label, classes, }) => {
    const noValuePlaceholder = (react_1.default.createElement(core_1.Typography, { className: classes.noValuePlaceholder }, label));
    const displayValue = react_1.default.createElement(core_1.Typography, null, value);
    return (react_1.default.createElement(core_1.Button, { onClick: onOpen, className: classes.selectButton, endIcon: react_1.default.createElement(ArrowDropDown_1.default, null) }, value ? displayValue : noValuePlaceholder));
};
const DialogSelect = ({ value, onChange, getOptions, retrieveOnSearch, localization = {}, InputComponent, closeOnSelect, hidden, allowMulti = false, defaultOpen = false, headerActionElement, loadOptionsByDefault = false, totalItems, dataLimit = 25, infiniteScroll = false, disableOption, DisabledOptionContent, onClose, primaryColor, primaryTextColor, primaryHoverColor, primaryHoverTextColor, }) => {
    const classes = (0, styles_1.useDialogSelectStyles)({
        primaryColor,
        primaryTextColor,
        primaryHoverColor,
        primaryHoverTextColor,
    });
    const [search, setSearch] = (0, react_1.useState)("");
    const [searchInputValue, setSearchInputValue] = (0, react_1.useState)("");
    const [open, setOpen] = (0, react_1.useState)(defaultOpen);
    const [fetchByDefault, setFetchByDefault] = (0, react_1.useState)(loadOptionsByDefault);
    const [options, setOptions] = (0, react_1.useState)([]);
    const [loading, setLoading] = (0, react_1.useState)(false);
    const [error, setError] = (0, react_1.useState)(null);
    const [page, setPage] = (0, react_1.useState)(START_PAGE);
    const [selectedOptions, setSelectedOptions] = (0, react_1.useState)([]);
    const [initialValue, setInitialValue] = (0, react_1.useState)(value);
    const areAllOptionsSelected = allowMulti && (value === null || value === void 0 ? void 0 : value.length) === options.length;
    const noSelectedOptions = !selectedOptions.length;
    const { placeholder = "Field", noDataTitle = "No data", noDataSubTitle = "Try searching for something else", errorTitle = "Error", errorSubTitle = "There was an error when retrieving the data", searchPlaceholder = "Search", doneButton = "Done", resetButton = "Close", selectAllButton = "Select All", deselectAllButton = "Deselect All", } = localization;
    // if paginated, fetch selected options to make sure they're initially
    // displayed in case they're not in the 1st results page
    (0, react_1.useEffect)(() => {
        if (!infiniteScroll) {
            return;
        }
        const hasValue = initialValue && Array.isArray(initialValue)
            ? initialValue.length > 0
            : initialValue;
        if (!hasValue) {
            return;
        }
        let unmounted = false;
        const fetchSelected = () => __awaiter(void 0, void 0, void 0, function* () {
            let initialValueSearch;
            let filterValues;
            if (Array.isArray(initialValue)) {
                const values = initialValue.map((value) => 
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                typeof value === "object" ? value.id : value);
                filterValues = values.length ? values : undefined;
            }
            else if (typeof initialValue === "object") {
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                initialValueSearch = initialValue.id;
            }
            else {
                initialValueSearch = initialValue;
            }
            if (!filterValues && !initialValueSearch) {
                return;
            }
            const existingOptions = yield (getOptions === null || getOptions === void 0 ? void 0 : getOptions(initialValueSearch, undefined, undefined, filterValues));
            if (!unmounted) {
                setInitialValue(undefined);
                if (!existingOptions) {
                    return;
                }
                setSelectedOptions(existingOptions.filter(({ id }) => {
                    if (Array.isArray(initialValue)) {
                        return (initialValue.find((value) => typeof value === "object"
                            ? // eslint-disable-next-line @typescript-eslint/no-explicit-any
                                value.id === id
                            : value === id) !== undefined);
                    }
                    else if (typeof initialValue === "object") {
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        return initialValue.id === id;
                    }
                    return initialValue === id;
                }));
            }
        });
        fetchSelected();
        return function cancel() {
            unmounted = true;
        };
    }, [initialValue, getOptions, infiniteScroll]);
    (0, react_1.useEffect)(() => {
        let unmounted = false;
        const resolveOptions = () => __awaiter(void 0, void 0, void 0, function* () {
            if (!retrieveOnSearch || search) {
                setLoading(true);
                setError(null);
                try {
                    if (open || fetchByDefault) {
                        const rawOptions = yield (getOptions === null || getOptions === void 0 ? void 0 : getOptions(search, dataLimit, START_PAGE));
                        if (!unmounted && rawOptions) {
                            setOptions(rawOptions);
                            setFetchByDefault(false);
                        }
                    }
                }
                catch (e) {
                    if (!unmounted) {
                        setError(e);
                    }
                }
                finally {
                    if (!unmounted) {
                        setLoading(false);
                    }
                }
            }
        });
        resolveOptions();
        return function cancel() {
            unmounted = true;
        };
    }, [getOptions, retrieveOnSearch, search, open, fetchByDefault, dataLimit]);
    // set selected options if initial value exists when not using infinite pagination
    (0, react_1.useEffect)(() => {
        if (!infiniteScroll && initialValue && options.length) {
            setSelectedOptions(options.filter(({ id }) => {
                if (Array.isArray(initialValue)) {
                    return (initialValue.find((value) => typeof value === "object"
                        ? // eslint-disable-next-line @typescript-eslint/no-explicit-any
                            value.id === id
                        : value === id) !== undefined);
                }
                else if (typeof initialValue === "object") {
                    // eslint-disable-next-line @typescript-eslint/no-explicit-any
                    return initialValue.id === id;
                }
                return initialValue === id;
            }));
            setInitialValue(undefined);
        }
    }, [infiniteScroll, initialValue, options]);
    (0, react_1.useEffect)(() => {
        // reset page when it closes if paginated
        if (!open && infiniteScroll) {
            setPage(START_PAGE);
            setOptions([]);
        }
    }, [open, value, infiniteScroll]);
    (0, react_1.useEffect)(() => {
        if (!value && !noSelectedOptions) {
            setSelectedOptions([]);
        }
    }, [value, noSelectedOptions]);
    // eslint-disable-next-line react-hooks/exhaustive-deps
    const debouncedSearchChange = (0, react_1.useCallback)((0, lodash_1.debounce)((value) => setSearch(value), 500), []);
    const handleClickOpen = () => {
        setOpen(true);
    };
    const handleClose = () => {
        setOpen(false);
        onClose === null || onClose === void 0 ? void 0 : onClose();
        if (search) {
            setPage(START_PAGE);
        }
    };
    const handleReset = () => {
        onChange === null || onChange === void 0 ? void 0 : onChange(null);
        setOpen(false);
        onClose === null || onClose === void 0 ? void 0 : onClose();
        setSelectedOptions([]);
    };
    const getNextOptions = (0, react_1.useCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        if (!open) {
            return;
        }
        try {
            setLoading(true);
            setError(null);
            const rawOptions = yield (getOptions === null || getOptions === void 0 ? void 0 : getOptions(search, dataLimit, page + 1));
            if (rawOptions) {
                setOptions((prevOptions) => [...prevOptions, ...rawOptions]);
            }
            setPage((prevPage) => prevPage + 1);
        }
        catch (error) {
            setError(error);
        }
        finally {
            setLoading(false);
        }
    }), [getOptions, search, dataLimit, page, open]);
    const handleChange = (newValue, option) => {
        if (closeOnSelect) {
            handleClose();
        }
        if (!allowMulti) {
            onChange === null || onChange === void 0 ? void 0 : onChange(newValue, option);
            setSelectedOptions([option]);
            return;
        }
        let actualValues = value || [];
        const index = typeof newValue === "string"
            ? actualValues.indexOf(newValue)
            : actualValues.findIndex(
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            (entry) => entry.id === newValue.id);
        if (index !== -1) {
            actualValues = [
                ...actualValues.slice(0, index),
                ...actualValues.slice(index + 1),
            ];
        }
        else {
            actualValues = [...actualValues, newValue];
        }
        onChange === null || onChange === void 0 ? void 0 : onChange(actualValues);
        // update selected options to keep track of items
        // that are not found in the 1st results page
        setSelectedOptions((prevOptions) => {
            const selectedIndex = prevOptions.findIndex((entry) => entry.id === option.id);
            let updatedOptions = prevOptions;
            if (selectedIndex !== -1) {
                updatedOptions = [
                    ...updatedOptions.slice(0, selectedIndex),
                    ...updatedOptions.slice(selectedIndex + 1),
                ];
            }
            else {
                updatedOptions = [...updatedOptions, option];
            }
            return updatedOptions;
        });
    };
    const handleSelectAllChange = (_e) => {
        const selectedAllOptions = options.map((option) => (option.value || option.id));
        onChange === null || onChange === void 0 ? void 0 : onChange(areAllOptionsSelected ? [] : selectedAllOptions);
        setSelectedOptions(areAllOptionsSelected ? [] : options);
    };
    const selected = (0, react_1.useMemo)(() => {
        if (allowMulti) {
            const selectedForMulti = options.filter((option) => Array.isArray(value) &&
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                value.some((entry) => typeof entry === "object"
                    ? option.id === entry.id
                    : entry === option.id));
            if (selectedForMulti.length === 0 ||
                (selectedOptions.length &&
                    selectedForMulti.length !== selectedOptions.length)) {
                return selectedOptions;
            }
            else {
                return selectedForMulti;
            }
        }
        const selectedForSingle = options.find((option) => option.id === value);
        return selectedForSingle || selectedOptions[0];
    }, [allowMulti, options, selectedOptions, value]);
    const defaultValue = value || (allowMulti ? [] : "");
    const currentValue = selected
        ? allowMulti
            ? selected.map(({ label }) => label).join(", ")
            : selected === null || selected === void 0 ? void 0 : selected.label
        : defaultValue;
    const getInputElement = () => {
        const props = {
            value: currentValue,
            secondary: Array.isArray(currentValue)
                ? undefined
                : selected === null || selected === void 0 ? void 0 : selected.secondary,
            onOpen: handleClickOpen,
            label: placeholder,
            classes,
        };
        return (InputComponent === null || InputComponent === void 0 ? void 0 : InputComponent(props)) || getDefaultInputElement(props);
    };
    if (hidden) {
        return react_1.default.createElement(react_1.default.Fragment, null);
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        getInputElement(),
        react_1.default.createElement(core_1.Dialog, { open: open, onClose: handleClose, PaperProps: { className: classes.paper }, scroll: "paper" },
            loading && react_1.default.createElement(core_1.LinearProgress, null),
            react_1.default.createElement(core_1.DialogTitle, { className: classes.dialogTitle },
                react_1.default.createElement(core_1.Paper, { component: "form", className: classes.searchRoot },
                    react_1.default.createElement(core_1.IconButton, { className: classes.iconButton, "aria-label": "menu", disabled: !search, onClick: () => {
                            setSearchInputValue("");
                            setSearch("");
                            setOptions([]);
                            setPage(START_PAGE);
                        } },
                        react_1.default.createElement(Close_1.default, null)),
                    react_1.default.createElement(core_1.InputBase, { value: searchInputValue, onChange: (e) => {
                            if (!e.target.value) {
                                setOptions([]);
                            }
                            setPage(START_PAGE);
                            setSearchInputValue(e.target.value);
                            debouncedSearchChange(e.target.value);
                        }, className: classes.input, placeholder: searchPlaceholder, inputProps: { "aria-label": "search input" } }),
                    react_1.default.createElement(core_1.Divider, { className: classes.divider, orientation: "vertical" }),
                    react_1.default.createElement(core_1.IconButton, { className: classes.iconButton, "aria-label": "directions" },
                        react_1.default.createElement(Search_1.default, null))),
                headerActionElement),
            react_1.default.createElement(core_1.DialogContent, { className: classes.dialogContent },
                react_1.default.createElement(core_1.List, { id: "scrollableContainer", className: classes.list, component: core_1.Paper },
                    react_1.default.createElement(react_infinite_scroll_component_1.default, { dataLength: options.length, next: getNextOptions, hasMore: (totalItems || options.length) > options.length, loader: react_1.default.createElement(react_1.default.Fragment, null), scrollableTarget: "scrollableContainer" }, options.map((option) => {
                        const isDisabled = disableOption
                            ? disableOption(option)
                            : false;
                        const isChecked = allowMulti && Array.isArray(value)
                            ? // eslint-disable-next-line @typescript-eslint/no-explicit-any
                                value.some((entry) => typeof entry === "object" && entry !== null
                                    ? entry.id === option.id
                                    : entry === option.id)
                            : option.id === value;
                        return (react_1.default.createElement(core_1.ListItem
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        , { 
                            // eslint-disable-next-line @typescript-eslint/no-explicit-any
                            button: !isDisabled, dense: true, key: `item-${option.id}`, onClick: () => {
                                if (isDisabled) {
                                    return;
                                }
                                handleChange(option.value || option.id, option);
                            }, className: (0, classnames_1.default)({ [classes.disabled]: isDisabled }) },
                            react_1.default.createElement(core_1.ListItemIcon, null,
                                react_1.default.createElement(core_1.Checkbox, { disabled: isDisabled, checked: !isDisabled && isChecked, className: classes.checkboxColors, style: {
                                        color: primaryColor,
                                    } })),
                            react_1.default.createElement(core_1.ListItemText, { primary: option.label, secondary: option.secondary, primaryTypographyProps: { variant: "subtitle2" } }),
                            isDisabled && (DisabledOptionContent === null || DisabledOptionContent === void 0 ? void 0 : DisabledOptionContent(option))));
                    })),
                    (!options.length || error) && (react_1.default.createElement("div", { className: classes.emptyState },
                        react_1.default.createElement("div", { className: classes.emptyStateIcon }, error ? react_1.default.createElement(Error_1.default, null) : react_1.default.createElement(List_1.default, null)),
                        react_1.default.createElement(core_1.Typography, { align: "center", variant: "h6", color: "textSecondary", component: "strong" }, error ? errorTitle : noDataTitle),
                        react_1.default.createElement(core_1.Typography, { align: "center", variant: "body1", color: "textSecondary", component: "p" }, error ? errorSubTitle : noDataSubTitle))))),
            react_1.default.createElement(core_1.DialogActions, { className: classes.actions },
                react_1.default.createElement(core_1.Grid, { container: true, item: true, xs: 12, spacing: 1 },
                    react_1.default.createElement(core_1.Grid, { item: true, xs: 6 }, allowMulti && (react_1.default.createElement(core_1.FormControlLabel, { control: react_1.default.createElement(core_1.Checkbox, { size: "small", checked: areAllOptionsSelected, onChange: handleSelectAllChange, className: classes.checkboxColors, style: {
                                color: primaryColor,
                            } }), labelPlacement: "end", label: areAllOptionsSelected ? deselectAllButton : selectAllButton, checked: areAllOptionsSelected, value: areAllOptionsSelected }))),
                    react_1.default.createElement(core_1.Grid, { item: true, xs: 3 },
                        react_1.default.createElement(core_1.Button, { onClick: handleReset }, resetButton)),
                    react_1.default.createElement(core_1.Grid, { item: true, xs: 3 }, !closeOnSelect && (react_1.default.createElement(core_1.Button, { onClick: handleClose, variant: "contained", color: "secondary", className: classes.inputColors }, doneButton))))))));
};
exports.DialogSelect = DialogSelect;
//# sourceMappingURL=DialogSelect.js.map