"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDialogSelectStyles = void 0;
const core_1 = require("@material-ui/core");
exports.useDialogSelectStyles = (0, core_1.makeStyles)((theme) => (0, core_1.createStyles)({
    dialogContent: {
        overflow: "hidden",
        display: "flex",
    },
    selectButton: {},
    search: {
        background: theme.palette.background.default,
        boxShadow: theme.shadows[1],
        width: "100%",
        maxWidth: "unset",
        "&:hover": {
            background: theme.palette.background.default,
        },
    },
    list: {
        overflow: "auto",
        maxHeight: "600px",
        width: "100%",
        marginBottom: theme.spacing(2),
    },
    paper: {
        background: theme.palette.background.default,
        overflow: "hidden",
    },
    dialogTitle: {
        display: "flex",
        "& > h2": {
            display: "flex",
            flexGrow: 1,
        },
    },
    searchRoot: {
        flexGrow: 1,
        padding: "2px 4px",
        display: "flex",
        alignItems: "center",
        minWidth: 400,
    },
    input: {
        marginLeft: theme.spacing(1),
        flex: 1,
    },
    iconButton: {
        padding: 10,
    },
    divider: {
        height: 28,
        margin: 4,
    },
    emptyState: {
        display: "block",
        textAlign: "center",
        margin: theme.spacing(3, 2),
    },
    emptyStateIcon: {
        display: "flex",
        margin: theme.spacing(1.5, "auto"),
        width: 100,
        height: 100,
        borderRadius: 100,
        background: theme.palette.background.default,
        justifyContent: "center",
        alignItems: "center",
        "& > svg": {
            width: 70,
            height: 70,
            fill: theme.palette.grey[400],
        },
    },
    noValuePlaceholder: {
        color: theme.palette.text.secondary,
    },
    actions: {
        background: theme.palette.background.paper,
        boxShadow: theme.shadows[1],
        borderTop: `1px solid ${theme.palette.grey[300]}`,
        overflow: "visible",
    },
    disabled: {
        backgroundColor: theme.palette.grey[200],
    },
    inputColors: ({ primaryColor, primaryTextColor, primaryHoverColor, primaryHoverTextColor, }) => (Object.assign(Object.assign(Object.assign({}, (primaryColor && { backgroundColor: primaryColor })), (primaryTextColor && { color: primaryTextColor })), { "&:hover": Object.assign(Object.assign({}, (primaryHoverColor && { backgroundColor: primaryHoverColor })), (primaryHoverTextColor && { color: primaryHoverTextColor })) })),
    checkboxColors: ({ primaryColor }) => (Object.assign({}, (primaryColor && { color: primaryColor }))),
}), { index: 1 });
//# sourceMappingURL=styles.js.map