import { ReactNode } from "react";
export interface DialogOption<T = string> {
    id: T | string;
    label: T | string;
    secondary?: T | string;
    source?: any;
    value?: any;
}
export interface DialogSelectLocalization {
    placeholder?: string;
    noDataTitle?: string;
    noDataSubTitle?: string;
    errorTitle?: string;
    errorSubTitle?: string;
    searchPlaceholder?: string;
    doneButton?: string;
    resetButton?: string;
    selectAllButton?: string;
    deselectAllButton?: string;
}
export interface SelectElementProps<T = string> {
    onOpen: () => void;
    value: string | T | T[] | null | undefined;
    label: T | string;
    classes: Record<string, string>;
    secondary?: T | string;
}
export interface DialogSelectPropTypes<T> {
    value?: T | T[] | null;
    onChange?: (newValue: T | T[] | null, option?: DialogOption<T>) => void;
    getOptions?: (search: string, limit?: number, page?: number, filter?: string[]) => Promise<DialogOption<T>[]> | DialogOption<T>[];
    retrieveOnSearch?: boolean;
    localization?: Partial<DialogSelectLocalization>;
    InputComponent?: (props: SelectElementProps<T>) => ReactNode;
    closeOnSelect?: boolean;
    hidden?: boolean;
    allowMulti?: boolean;
    defaultOpen?: boolean;
    headerActionElement?: ReactNode;
    loadOptionsByDefault?: boolean;
    totalItems?: number;
    dataLimit?: number;
    infiniteScroll?: boolean;
    disableOption?: (option: DialogOption<T>) => boolean;
    DisabledOptionContent?: (option: DialogOption<T>) => JSX.Element;
    onClose?: () => void;
    primaryColor?: string;
    primaryTextColor?: string;
    primaryHoverColor?: string;
    primaryHoverTextColor?: string;
}
