"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dropdown = void 0;
const icons_1 = require("@material-ui/icons");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const colors_1 = require("../../constants/colors");
const defaultLayouts_1 = require("../../constants/defaultLayouts");
const useClickOutside_1 = require("../../hooks/useClickOutside");
const styles_1 = require("./styles");
const Dropdown = ({ id, className, name, options = [], withCustomOption = false, selectedValue = "", withCustomSelectedValue = false, controlled = false, containerMargin = defaultLayouts_1.DEFAULT_MARGIN, containerPadding = defaultLayouts_1.DEFAULT_PADDING, containerWidth = defaultLayouts_1.DEFAULT_WIDTH, containerHeight = defaultLayouts_1.DEFAULT_HEIGHT, optionMargin = defaultLayouts_1.DEFAULT_MARGIN, optionPadding = defaultLayouts_1.DEFAULT_PADDING, optionWidth = defaultLayouts_1.DEFAULT_WIDTH, optionHeight = defaultLayouts_1.DEFAULT_HEIGHT, optionsContainerWidth = defaultLayouts_1.DEFAULT_WIDTH, optionsContainerHeight = colors_1.AUTO, withArrow = true, labelText, labelBackgroundColor = colors_1.DEFAULT_BACKGROUND, labelTextColor = colors_1.DEFAULT_PRIMARY, backgroundColor = colors_1.DEFAULT_BACKGROUND, textColor = colors_1.DEFAULT_PRIMARY, selectedOptionBackgroundColor = colors_1.DEFAULT_PRIMARY_HOVER, hoverOptionBackgroundColor = colors_1.DEFAULT_BACKGROUND, hoverOptionTextColor = colors_1.DEFAULT_PRIMARY, cursor = defaultLayouts_1.DEFAULT_CURSOR, onChange, onFocus, onBlur, }) => {
    const [isOpen, setIsOpen] = (0, react_1.useState)(false);
    const [value, setValue] = (0, react_1.useState)();
    const dropdownRef = (0, react_1.useRef)(null);
    const handleClickOutside = (0, react_1.useCallback)(() => setIsOpen(false), []);
    (0, useClickOutside_1.useOnClickOutside)(dropdownRef, handleClickOutside);
    if (controlled && !onChange) {
        console.warn("Controlled input requires onChance property");
    }
    const handleChange = (0, react_1.useCallback)((val) => {
        if (controlled) {
            onChange === null || onChange === void 0 ? void 0 : onChange(val.key);
        }
        else {
            setValue(val);
        }
    }, [controlled, onChange]);
    const toggleOpen = (0, react_1.useCallback)(() => {
        setIsOpen((prevIsOpen) => !prevIsOpen);
    }, []);
    return (react_1.default.createElement(styles_1.Container, { id: id, className: className, margin: containerMargin, padding: containerPadding, width: containerWidth, height: containerHeight, backgroundColor: backgroundColor, textColor: textColor, cursor: cursor, onFocus: onFocus, onBlur: onBlur, onClick: toggleOpen, ref: dropdownRef },
        labelText && (react_1.default.createElement(styles_1.LabelContainer, { backgroundColor: labelBackgroundColor, textColor: labelTextColor },
            react_1.default.createElement(styles_1.Label, null, labelText))),
        react_1.default.createElement(styles_1.DropdownContainer, null,
            withCustomSelectedValue ? (selectedValue) : (react_1.default.createElement(styles_1.SelectedValue, { name: name, value: controlled ? selectedValue : value === null || value === void 0 ? void 0 : value.content, disabled: true, cursor: cursor })),
            withArrow &&
                (isOpen ? (react_1.default.createElement(icons_1.ExpandLess, { width: defaultLayouts_1.DEFAULT_BUTTON_ICON_SIZE, height: defaultLayouts_1.DEFAULT_BUTTON_ICON_SIZE })) : (react_1.default.createElement(icons_1.ExpandMore, { width: defaultLayouts_1.DEFAULT_BUTTON_ICON_SIZE, height: defaultLayouts_1.DEFAULT_BUTTON_ICON_SIZE })))),
        react_1.default.createElement(styles_1.OptionContainer, { className: (0, classnames_1.default)({ open: isOpen }), width: optionsContainerWidth, height: optionsContainerHeight }, withCustomOption
            ? options
            : options.map(({ key, content }) => (react_1.default.createElement(styles_1.Option, { key: key, className: (0, classnames_1.default)(key, {
                    selected: controlled
                        ? content === selectedValue
                        : key === (value === null || value === void 0 ? void 0 : value.key),
                }), onClick: () => handleChange({ key, content }), margin: optionMargin, padding: optionPadding, width: optionWidth, height: optionHeight, hoverBackgroundColor: hoverOptionBackgroundColor, hoverTextColor: hoverOptionTextColor, backgroundColor: selectedOptionBackgroundColor }, content))))));
};
exports.Dropdown = Dropdown;
//# sourceMappingURL=Dropdown.js.map