"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Option = exports.OptionContainer = exports.SelectedValue = exports.DropdownContainer = exports.Label = exports.LabelContainer = exports.Container = void 0;
const styled_components_1 = __importDefault(require("styled-components"));
exports.Container = styled_components_1.default.div `
  display: flex;
  flex-direction: column;
  align-items: center;
  margin: ${({ margin }) => margin};
  padding: ${({ padding }) => padding};
  width: ${({ width }) => width};
  height: ${({ height }) => height};
  background-color: ${({ backgroundColor }) => backgroundColor};
  color: ${({ textColor }) => textColor};
  cursor: ${({ cursor }) => cursor};
  position: relative;
`;
exports.LabelContainer = styled_components_1.default.div `
  display: flex;
  justify-content: flex-start;
  width: 100%;
  background-color: ${({ backgroundColor }) => backgroundColor};
  color: ${({ textColor }) => textColor};
`;
exports.Label = styled_components_1.default.span ``;
exports.DropdownContainer = styled_components_1.default.div `
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
  width: 100%;
`;
exports.SelectedValue = styled_components_1.default.input `
  background-color: transparent;
  border: 1px solid rgba(0, 0, 0, 0);
  border-bottom: 1px solid ${({ textColor }) => textColor};
  width: 100%;
  cursor: ${({ cursor }) => cursor};
`;
exports.OptionContainer = styled_components_1.default.div `
  width: ${({ width }) => width};
  display: flex;
  flex-direction: column;
  align-items: center;
  position: absolute;
  top: 50px;
  left: 0;
  transition: height 0.3s ease-in-out;
  transition-delay: 0.1s;
  height: 0;
  overflow: hidden;

  &.open {
    height: ${({ height }) => height};
    overflow-y: auto;
  }
`;
exports.Option = styled_components_1.default.div `
  display: flex;
  justify-content: center;
  align-items: center;
  margin: ${({ margin }) => margin};
  padding: ${({ padding }) => padding};
  width: ${({ width }) => width};
  height: ${({ height }) => height};
  &:hover {
    background-color: ${({ hoverBackgroundColor }) => hoverBackgroundColor};
    color: ${({ hoverTextColor }) => hoverTextColor};
  }

  &.selected {
    background-color: ${({ backgroundColor }) => backgroundColor};
  }
`;
//# sourceMappingURL=styles.js.map