"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IconButton = void 0;
const IconButton_1 = __importDefault(require("@material-ui/core/IconButton"));
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importDefault(require("react"));
const colors_1 = require("../../constants/colors");
const cursorTypes_1 = require("../../types/cursorTypes");
const Button_1 = require("../Button");
const styles_1 = require("./styles");
const IconButton = ({ className, id, name, type = Button_1.ButtonTypes.BUTTON, children, padding, margin, outline, border, borderRadius, width = colors_1.AUTO, height = colors_1.AUTO, maxWidth = colors_1.AUTO, maxHeight = colors_1.AUTO, backgroundColor, textColor, hoverBackgroundColor, hoverTextColor, cursor = cursorTypes_1.CursorType.POINTER, disabled = false, title, onClick, onFocus, onBlur, }) => {
    const classes = (0, styles_1.useStyle)({
        padding,
        margin,
        outline,
        border,
        borderRadius,
        width,
        height,
        maxWidth,
        maxHeight,
        backgroundColor,
        textColor,
        cursor,
        hoverBackgroundColor,
        hoverTextColor,
    });
    return (react_1.default.createElement(IconButton_1.default, { className: (0, classnames_1.default)(classes.root, className), id: id, name: name, type: type, disabled: disabled, onClick: onClick, onFocus: onFocus, onBlur: onBlur, title: title }, children));
};
exports.IconButton = IconButton;
//# sourceMappingURL=IconButton.js.map