"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileInput = void 0;
const core_1 = require("@material-ui/core");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importDefault(require("react"));
const styles_1 = require("../styles");
const FileInput = ({ className, name, id, padding, margin, required, disabled, onChange, onFocus, onBlur, error, errorBackgroundColor, errorTextColor, helperTextBackgroundColor, helperTextTextColor, textColor, labelText, helperText, icon, }) => {
    const classes = (0, styles_1.useStyle)({
        padding,
        margin,
        errorBackgroundColor,
        errorTextColor,
        helperTextBackgroundColor,
        helperTextTextColor,
        textColor,
        icon,
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.Button, { className: (0, classnames_1.default)(classes.root, className), id: id, variant: "contained", component: "label", disabled: disabled, onFocus: onFocus, onBlur: onBlur },
            icon ? icon : labelText,
            react_1.default.createElement("input", { type: "file", name: name, hidden: true, required: required, disabled: disabled, onChange: onChange })),
        (error || helperText) && (react_1.default.createElement(styles_1.FileHelperText, { error: !!error, helperText: !!helperText, errorBackgroundColor: errorBackgroundColor, errorTextColor: errorTextColor, helperTextBackgroundColor: helperTextBackgroundColor, helperTextTextColor: helperTextTextColor }, error ? error : helperText))));
};
exports.FileInput = FileInput;
//# sourceMappingURL=FileInput.js.map