"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PasswordInput = void 0;
const core_1 = require("@material-ui/core");
const TextField_1 = __importDefault(require("@material-ui/core/TextField"));
const icons_1 = require("@material-ui/icons");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const Icon_1 = require("../../Icon");
const styles_1 = require("../styles");
const inputTypes_1 = require("../types/inputTypes");
const PasswordInput = ({ type, withShowHide = true, icon, iconSize, className, name, id, value, padding, margin, required, autoFocus, disabled, onChange, onFocus, onBlur, placeholder, error, errorBackgroundColor, errorTextColor, helperTextBackgroundColor, helperTextTextColor, textColor, labelText, helperText, defaultValue, }) => {
    const classes = (0, styles_1.useStyle)({
        padding,
        margin,
        errorBackgroundColor,
        errorTextColor,
        textColor,
        helperTextBackgroundColor,
        helperTextTextColor,
    });
    const [isVisible, setVisibility] = (0, react_1.useState)(false);
    const inputType = withShowHide && isVisible ? inputTypes_1.InputTypes.TEXT : type;
    const toggleVisiblity = (0, react_1.useCallback)(() => setVisibility((prevVisiblity) => !prevVisiblity), []);
    return (react_1.default.createElement(TextField_1.default, { type: inputType, id: id, className: (0, classnames_1.default)(classes.root, className), name: name, value: value, required: required, 
        // eslint-disable-next-line jsx-a11y/no-autofocus
        autoFocus: autoFocus, disabled: disabled, onChange: onChange, onFocus: onFocus, onBlur: onBlur, placeholder: placeholder, error: !!error, label: labelText, helperText: error ? error : helperText, defaultValue: defaultValue, InputProps: {
            className: (0, classnames_1.default)(classes.textColor),
            endAdornment: withShowHide && (react_1.default.createElement(core_1.InputAdornment, { position: "end" }, icon ? (react_1.default.createElement(Icon_1.Icon, { src: icon, onClick: toggleVisiblity, width: iconSize, height: iconSize })) : (react_1.default.createElement(core_1.IconButton, { "aria-label": "toggle password visibility", onClick: toggleVisiblity, edge: "end" }, isVisible ? react_1.default.createElement(icons_1.VisibilityOff, null) : react_1.default.createElement(icons_1.Visibility, null))))),
        }, FormHelperTextProps: Object.assign(Object.assign({}, (error && { className: (0, classnames_1.default)(classes.error) })), (!error &&
            helperText && { className: (0, classnames_1.default)(classes.helperText) })), InputLabelProps: Object.assign({}, (error && { className: (0, classnames_1.default)(classes.error) })) }));
};
exports.PasswordInput = PasswordInput;
//# sourceMappingURL=PasswordInput.js.map