"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadioInput = void 0;
const core_1 = require("@material-ui/core");
const Radio_1 = __importDefault(require("@material-ui/core/Radio"));
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importDefault(require("react"));
const styles_1 = require("../styles");
const RadioInput = ({ id, name, className, value, padding, margin, required, labelText, autoFocus, disabled, onChange, onFocus, onBlur, checked, textColor, }) => {
    const classes = (0, styles_1.useStyle)({
        padding,
        margin,
        textColor,
    });
    return (react_1.default.createElement(core_1.RadioGroup, null,
        react_1.default.createElement(core_1.FormControlLabel, { label: labelText, control: react_1.default.createElement(Radio_1.default, { id: id, name: name, className: (0, classnames_1.default)(classes.textColor, className), value: value, required: required, 
                // eslint-disable-next-line jsx-a11y/no-autofocus
                autoFocus: autoFocus, disabled: disabled, onChange: onChange, onFocus: onFocus, onBlur: onBlur, checked: checked }) })));
};
exports.RadioInput = RadioInput;
//# sourceMappingURL=RadioInput.js.map