"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiStepper = void 0;
const Button_1 = __importDefault(require("@material-ui/core/Button"));
const Step_1 = __importDefault(require("@material-ui/core/Step"));
const StepLabel_1 = __importDefault(require("@material-ui/core/StepLabel"));
const Stepper_1 = __importDefault(require("@material-ui/core/Stepper"));
const Typography_1 = __importDefault(require("@material-ui/core/Typography"));
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const react_hook_form_1 = require("react-hook-form");
const CustomConnector_1 = require("./CustomConnector");
const styles_1 = require("./styles");
const MultiStepper = ({ className, id, width, maxWidth, height, maxHeight, border, borderRadius, outline, padding, margin, backgroundColor, textColor, lineColor, activeLineColor, completedLineColor, steps, onSubmit, currentIcon, processedIcon, unprocessedIcon, allStepsCompletedMessage = "All steps completed", submitButtonText = "Submit", backButtonText = "Back", lastStepNextButtonText = "Finish", nextButtonText = "Next", }) => {
    const classes = (0, styles_1.useMultiStepperStyles)({
        width,
        height,
        maxWidth,
        maxHeight,
        border,
        borderRadius,
        outline,
        padding,
        margin,
        backgroundColor,
        textColor,
    });
    const [activeStep, setActiveStep] = (0, react_1.useState)(0);
    const { register, handleSubmit, setValue, formState: { errors }, } = (0, react_hook_form_1.useForm)();
    const Connector = (0, CustomConnector_1.CustomConnector)({
        lineColor,
        activeLineColor,
        completedLineColor,
    });
    const handleNext = () => {
        setActiveStep((prevActiveStep) => prevActiveStep + 1);
    };
    const handleBack = () => {
        setActiveStep((prevActiveStep) => prevActiveStep - 1);
    };
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const onSubmitForm = (data) => {
        onSubmit(data);
    };
    const currentStep = steps[activeStep];
    const isLastStep = activeStep === steps.length - 1;
    return (react_1.default.createElement("form", { onSubmit: handleSubmit(onSubmitForm) },
        react_1.default.createElement("div", { id: id, className: (0, classnames_1.default)(classes.root, className) },
            react_1.default.createElement(Stepper_1.default, { activeStep: activeStep, alternativeLabel: true, connector: react_1.default.createElement(Connector, null) }, steps.map((step, index) => {
                let icon;
                if (index === activeStep) {
                    icon = step.currentIcon || currentIcon;
                }
                else if (index < activeStep) {
                    icon = step.processedIcon || processedIcon;
                }
                else {
                    icon = step.unprocessedIcon || unprocessedIcon;
                }
                return (react_1.default.createElement(Step_1.default, { key: step.label },
                    react_1.default.createElement(StepLabel_1.default, Object.assign({}, (icon && { icon })), step.label)));
            })),
            react_1.default.createElement(styles_1.ContentContainer, null, activeStep === steps.length ? (react_1.default.createElement("div", null,
                react_1.default.createElement(Typography_1.default, { className: classes.instructions }, allStepsCompletedMessage),
                react_1.default.createElement(Button_1.default, { type: "submit" }, submitButtonText))) : (react_1.default.createElement("div", null,
                react_1.default.cloneElement(currentStep.component, {
                    register,
                    setValue,
                    errors,
                }),
                react_1.default.createElement("div", null,
                    react_1.default.createElement(Button_1.default, { disabled: activeStep === 0, onClick: handleBack, className: classes.backButton }, backButtonText),
                    react_1.default.createElement(Button_1.default, { variant: "contained", color: "primary", onClick: handleNext }, isLastStep ? lastStepNextButtonText : nextButtonText))))))));
};
exports.MultiStepper = MultiStepper;
//# sourceMappingURL=MultiStepper.js.map