"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormatNumber = void 0;
const react_1 = __importStar(require("react"));
const react_intl_1 = require("react-intl");
const formatDate_1 = require("../../../helpers/formatDate");
const NUMBER_DECIMAL_SEPARATOR = ".";
const NUMBER_THOUSANDS_SEPARATOR = ",";
const NUMBER_DECIMAL_SCALE = 2;
const FormatNumber = ({ value, format, }) => {
    const { hasDecimalSeparator, decimalSeparator, hasThousandsSeparator, thousandsSeparator, } = format || formatDate_1.defaultAmountFormat;
    const addDecimals = (0, react_1.useCallback)((parts) => {
        const found = parts === null || parts === void 0 ? void 0 : parts.find((part) => part.type === "fraction");
        if (found) {
            return "";
        }
        if (hasDecimalSeparator) {
            return `${decimalSeparator}${"0".repeat(NUMBER_DECIMAL_SCALE)}`;
        }
        return `${NUMBER_DECIMAL_SEPARATOR}${"0".repeat(NUMBER_DECIMAL_SCALE)}`;
    }, [decimalSeparator, hasDecimalSeparator]);
    if (value === null || value === undefined) {
        return react_1.default.createElement(react_1.default.Fragment, null);
    }
    return (react_1.default.createElement(react_intl_1.FormattedNumberParts, { value: value }, (parts) => (react_1.default.createElement(react_1.default.Fragment, null,
        parts.map((part) => {
            if (hasThousandsSeparator &&
                part.value === NUMBER_THOUSANDS_SEPARATOR) {
                return thousandsSeparator;
            }
            if (hasDecimalSeparator &&
                part.value === NUMBER_DECIMAL_SEPARATOR) {
                return decimalSeparator;
            }
            if (part.type === "fraction") {
                return part.value.length <= NUMBER_DECIMAL_SCALE
                    ? part.value +
                        "0".repeat(NUMBER_DECIMAL_SCALE - part.value.length)
                    : part.value.substring(0, NUMBER_DECIMAL_SCALE);
            }
            return part.value;
        }),
        addDecimals(parts)))));
};
exports.FormatNumber = FormatNumber;
//# sourceMappingURL=FormatNumber.js.map