"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableActions = void 0;
const core_1 = require("@material-ui/core");
const Delete_1 = __importDefault(require("@material-ui/icons/Delete"));
const Edit_1 = __importDefault(require("@material-ui/icons/Edit"));
const react_1 = __importDefault(require("react"));
const getActionsCount_1 = require("../../../helpers/getActionsCount");
const RowPopup_1 = require("../RowPopup/RowPopup");
const types_1 = require("../types");
const styles_1 = require("./styles");
const TableConfirmActions_1 = require("./TableConfirmActions");
const TableActions = ({ row, newRow, setNewRow, actions, actionsNotification, tableStatus, setTableStatus, selectKey, disabled, setActionableRow, }) => {
    var _a, _b, _c;
    const classes = (0, styles_1.useTableActionsStyles)();
    const isActionDisabled = disabled ||
        ((tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode) ? tableStatus.activeRow !== row[selectKey] : false);
    const { rowActions } = (0, getActionsCount_1.getActionsCount)(actions);
    const hideEditAction = (actions === null || actions === void 0 ? void 0 : actions.hideEdit) && actions.hideEdit(row);
    const hideDeleteAction = (actions === null || actions === void 0 ? void 0 : actions.hideDelete) && actions.hideDelete(row);
    const rowIdentifier = row[selectKey];
    const setTableMode = (tableMode) => {
        setNewRow === null || setNewRow === void 0 ? void 0 : setNewRow(row);
        setTableStatus === null || setTableStatus === void 0 ? void 0 : setTableStatus({ activeRow: rowIdentifier, tableMode });
    };
    const validActions = (_b = (_a = actions === null || actions === void 0 ? void 0 : actions.rowActions) === null || _a === void 0 ? void 0 : _a.call(actions, row)) === null || _b === void 0 ? void 0 : _b.some(({ isPermitted }) => isPermitted === true || isPermitted === undefined);
    const confirmActionsEnabled = (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.activeRow) === rowIdentifier && rowIdentifier !== undefined;
    return (react_1.default.createElement(core_1.TableCell, { className: classes.actionCell, style: { width: rowActions * TableConfirmActions_1.ROW_ACTIONS_WIDTH } },
        (actions === null || actions === void 0 ? void 0 : actions.rowActions) && validActions && (react_1.default.createElement(RowPopup_1.RowPopup, { row: row, actions: (_c = actions === null || actions === void 0 ? void 0 : actions.rowActions) === null || _c === void 0 ? void 0 : _c.call(actions, row), setActionableRow: setActionableRow })),
        confirmActionsEnabled ? (react_1.default.createElement(TableConfirmActions_1.TableConfirmActions, { setTableStatus: setTableStatus, notify: actionsNotification, tableStatus: tableStatus, row: row, newRow: newRow, actions: actions })) : (react_1.default.createElement(react_1.default.Fragment, null,
            !hideEditAction && (actions === null || actions === void 0 ? void 0 : actions.onRowEdit) && (react_1.default.createElement(core_1.Tooltip, { title: "Edit" },
                react_1.default.createElement("span", null,
                    react_1.default.createElement(core_1.IconButton, { size: "small", disabled: isActionDisabled, "aria-label": "edit", onClick: () => setTableMode(types_1.TableMode.EDIT) },
                        react_1.default.createElement(Edit_1.default, null))))),
            !hideDeleteAction && (actions === null || actions === void 0 ? void 0 : actions.onRowDelete) && (react_1.default.createElement(core_1.Tooltip, { title: "Remove" },
                react_1.default.createElement("span", null,
                    react_1.default.createElement(core_1.IconButton, { size: "small", disabled: isActionDisabled, "aria-label": "remove", onClick: () => setTableMode(types_1.TableMode.DELETE) },
                        react_1.default.createElement(Delete_1.default, null))))),
            hideDeleteAction && (actions === null || actions === void 0 ? void 0 : actions.disableDeleteTooltip) && (react_1.default.createElement(core_1.Tooltip, { title: actions.disableDeleteTooltip },
                react_1.default.createElement("span", null,
                    react_1.default.createElement(core_1.IconButton, { size: "small", disabled: true, "aria-label": "remove-disabled" },
                        react_1.default.createElement(Delete_1.default, null)))))))));
};
exports.TableActions = TableActions;
//# sourceMappingURL=TableActions.js.map