import React, { PropsWithChildren } from "react";
import { FiltersType, TableProps } from "../types";
export interface TableBodyProps<T> extends Pick<TableProps<T>, "columns" | "data" | "actions" | "tableStatus" | "setTableStatus" | "setTableFilters" | "border" | "customStyle" | "hoverableTableRow" | "onRowClick" | "actionsNotification" | "collapsableRows" | "isDisabled" | "ExpandableRowContent" | "isHighlighted" | "hiddenHeader"> {
    selectedRows: T[keyof T][];
    selectKey: keyof T;
    filters?: FiltersType<T>;
    hidden?: boolean;
}
export declare const TableBody: <T extends {
    className?: string | undefined;
}>({ columns, data, customStyle, hidden, border, filters, setTableFilters, actions, tableStatus, isDisabled, setTableStatus, isHighlighted, hiddenHeader, ...rest }: React.PropsWithChildren<TableBodyProps<T>>) => JSX.Element;
