"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableBody = void 0;
const core_1 = require("@material-ui/core");
const react_1 = __importDefault(require("react"));
const styles_1 = require("../styles");
const TableAddRow_1 = require("../TableRow/TableAddRow");
const TableRow_1 = require("../TableRow/TableRow");
const types_1 = require("../types");
const TableColumnFilter_1 = require("./TableColumnFilter");
const TableBody = (_a) => {
    var { columns, data, customStyle, hidden, border, filters, setTableFilters, actions, tableStatus, isDisabled, setTableStatus, isHighlighted, hiddenHeader = false } = _a, rest = __rest(_a, ["columns", "data", "customStyle", "hidden", "border", "filters", "setTableFilters", "actions", "tableStatus", "isDisabled", "setTableStatus", "isHighlighted", "hiddenHeader"]);
    const classes = (0, styles_1.useStyle)({ border, customStyle });
    const hasActions = [actions === null || actions === void 0 ? void 0 : actions.onRowAdd, actions === null || actions === void 0 ? void 0 : actions.onRowDelete, actions === null || actions === void 0 ? void 0 : actions.rowActions].filter((action) => action).length > 0 || !!(actions === null || actions === void 0 ? void 0 : actions.headerActions);
    const handleFilterUpdate = (e, column, isStartValue = true) => {
        const { field, type } = column;
        const params = {};
        let value = e == null ? "" : e instanceof Date ? e.toISOString() : e.target.value;
        const initialValue = filters === null || filters === void 0 ? void 0 : filters[field];
        if (["date-range", "amount-range", "date-time-tange"].includes(type || "")) {
            let start;
            let end;
            if (initialValue && Array.isArray(initialValue)) {
                [start, end] = initialValue;
            }
            value = isStartValue ? [value, end || ""] : [start || "", value];
        }
        params[field] = value;
        setTableFilters(params);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.TableBody, null, !hiddenHeader && (react_1.default.createElement(TableColumnFilter_1.TableColumnFilter, { columns: columns, filters: filters || {}, onChange: handleFilterUpdate, classes: classes, hasActions: hasActions }))),
        !hidden && (react_1.default.createElement(core_1.Fade, { in: true },
            react_1.default.createElement(core_1.TableBody, { className: classes.tableBody },
                (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode) === types_1.TableMode.ADD && (react_1.default.createElement(TableAddRow_1.TableAddRow, { columns: columns, actions: actions, tableStatus: tableStatus, actionsNotification: rest === null || rest === void 0 ? void 0 : rest.actionsNotification, setTableStatus: setTableStatus })),
                data.map((row, index) => (react_1.default.createElement(TableRow_1.TableRow, Object.assign({ key: index, row: row, hasActions: hasActions, columns: columns, actions: actions, tableStatus: tableStatus, setTableStatus: setTableStatus, isDisabled: isDisabled, isHighlighted: isHighlighted }, rest)))))))));
};
exports.TableBody = TableBody;
//# sourceMappingURL=TableBody.js.map