"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableFooter = void 0;
const core_1 = require("@material-ui/core");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importDefault(require("react"));
const styles_1 = require("../styles");
const TableFooter = ({ pagination, paginationClassName, limit, page, totalItems, rowsPerPageOptions, setTableStatus, setLimit, setPage, }) => {
    const classes = (0, styles_1.useStyle)({});
    const handleChangePage = (_event, newPage) => {
        setTableStatus === null || setTableStatus === void 0 ? void 0 : setTableStatus({});
        setPage(newPage);
    };
    const handleChangeRowsPerPage = (event) => {
        setLimit(+event.target.value);
    };
    return (react_1.default.createElement(core_1.TableFooter, null,
        react_1.default.createElement(core_1.Grid, { item: true, container: true, className: classes.tableFooter, xs: 12, spacing: 2 }, pagination && (react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
            react_1.default.createElement(core_1.TablePagination, { className: (0, classnames_1.default)(classes.pagination, paginationClassName), rowsPerPageOptions: rowsPerPageOptions, component: "div", count: totalItems || 0, rowsPerPage: limit, page: page, onPageChange: handleChangePage, onRowsPerPageChange: handleChangeRowsPerPage, SelectProps: { inputProps: { id: "rowsPerPage-input" } }, labelRowsPerPage: react_1.default.createElement("label", { htmlFor: "rowsPerPage-input" }, "Rows per page:") }))))));
};
exports.TableFooter = TableFooter;
//# sourceMappingURL=TableFooter.js.map