"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableHead = void 0;
const core_1 = require("@material-ui/core");
const icons_1 = require("@material-ui/icons");
const re_resizable_1 = require("re-resizable");
const react_1 = __importStar(require("react"));
const getActionsCount_1 = require("../../../helpers/getActionsCount");
const RowPopup_1 = require("../RowPopup/RowPopup");
const styles_1 = require("../styles");
const TableLoadingState_1 = require("../TableLoadingState/TableLoadingState");
const types_1 = require("../types");
const ENABLE = {
    top: false,
    right: true,
    bottom: false,
    left: false,
    topRight: false,
    bottomRight: false,
    bottomLeft: false,
    topLeft: false,
};
var CellWidthIndex;
(function (CellWidthIndex) {
    CellWidthIndex[CellWidthIndex["MIN"] = 9] = "MIN";
    CellWidthIndex[CellWidthIndex["MAX"] = 54] = "MAX";
})(CellWidthIndex || (CellWidthIndex = {}));
const TableHead = ({ columns, border, customStyle, actions, tableStatus, setTableStatus, order, orderBy, setOrderBy, hidden = false, resizeColumns = true, }) => {
    var _a;
    const classes = (0, styles_1.useStyle)({ border, customStyle, hiddenHeader: hidden });
    const { actionsCount } = (0, getActionsCount_1.getActionsCount)(actions);
    const hasHeaderActions = (actions === null || actions === void 0 ? void 0 : actions.headerActions) && ((_a = actions === null || actions === void 0 ? void 0 : actions.headerActions) === null || _a === void 0 ? void 0 : _a.length) > 0;
    const createSortHandler = (columnId) => () => {
        setOrderBy(columnId);
    };
    const getIsResizable = (enable, resizable) => resizable ? enable : Object.assign(Object.assign({}, enable), { right: resizable });
    const handleOnResizeStop = (0, react_1.useCallback)((_event, _d, refElement, delta) => {
        const refWidth = parseInt(refElement.style.width.replace("px", "")) || 0;
        const { width: deltaWidth } = delta;
        const cellText = refElement.innerText;
        const minCellWidth = cellText.length * CellWidthIndex.MIN;
        const maxCellWidth = cellText.length * CellWidthIndex.MAX;
        if (deltaWidth < 0 && refWidth < minCellWidth) {
            refElement.style.width = `${minCellWidth}px`;
        }
        else if (deltaWidth > 0 && refWidth > maxCellWidth) {
            refElement.style.width = `${maxCellWidth}px`;
        }
    }, []);
    const SortableLabel = ({ column, }) => (react_1.default.createElement(core_1.Tooltip, { title: "Sort" },
        react_1.default.createElement(core_1.TableSortLabel, { active: orderBy === column.field, direction: orderBy === column.field ? order || undefined : types_1.TableOrder.ASC, onClick: createSortHandler(column.field) },
            column.label,
            orderBy === column.field ? (react_1.default.createElement("span", { style: { display: "none" } }, order === types_1.TableOrder.ASC ? "ascending" : "descending")) : null)));
    const AddNewRow = () => (react_1.default.createElement(core_1.Tooltip, { title: "Add" },
        react_1.default.createElement("span", null,
            react_1.default.createElement(core_1.IconButton, { className: classes.addButton, size: "small", color: "secondary", disabled: !!(tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode), "aria-label": "add", onClick: () => setTableStatus === null || setTableStatus === void 0 ? void 0 : setTableStatus({ tableMode: types_1.TableMode.ADD }) },
                react_1.default.createElement(icons_1.Add, null)))));
    return (react_1.default.createElement(core_1.TableHead, { className: classes.tableHead },
        react_1.default.createElement(core_1.TableRow, null,
            actionsCount > 0 && (react_1.default.createElement(core_1.TableCell, { className: classes.tableActionCell, style: { width: actionsCount * TableLoadingState_1.ROW_ACTION_SKELETON_WIDTH } },
                react_1.default.createElement("span", { className: classes.tableActionWrapper },
                    hasHeaderActions && (react_1.default.createElement(RowPopup_1.RowPopup, { className: classes.addButton, color: "secondary", actions: (actions === null || actions === void 0 ? void 0 : actions.headerActions) || [] })),
                    (actions === null || actions === void 0 ? void 0 : actions.onRowAdd) && react_1.default.createElement(AddNewRow, null)))),
            columns.map((column) => (react_1.default.createElement(core_1.TableCell, Object.assign({ key: `${String(column.field)}` }, (column.additionalCellProps &&
                typeof column.additionalCellProps === "object" && Object.assign({}, column.additionalCellProps)), { align: column.alignHeader || types_1.TableColumnAlign.LEFT, className: classes.tableHeadCell }),
                react_1.default.createElement(re_resizable_1.Resizable, { className: resizeColumns ? classes.resizableWrapper : undefined, enable: getIsResizable(ENABLE, resizeColumns), onResizeStop: handleOnResizeStop }, column.sortable ? (react_1.default.createElement(SortableLabel, { column: column })) : (column.label))))))));
};
exports.TableHead = TableHead;
//# sourceMappingURL=TableHead.js.map