"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableLoadingState = exports.ROW_ACTION_SKELETON_WIDTH = void 0;
const core_1 = require("@material-ui/core");
const lab_1 = require("@material-ui/lab");
const react_1 = __importDefault(require("react"));
const getActionsCount_1 = require("../../../helpers/getActionsCount");
const styles_1 = require("../TableRow/styles");
const TableLoadingRow_1 = require("../TableRow/TableLoadingRow");
exports.ROW_ACTION_SKELETON_WIDTH = 40;
const DEFAULT_NUMBER_OF_ROWS = 5;
const TableLoadingState = ({ columns, actions, numberOfRows = DEFAULT_NUMBER_OF_ROWS, }) => {
    const { rowActions } = (0, getActionsCount_1.getActionsCount)(actions);
    const classes = (0, styles_1.useTableRowStyles)();
    return (react_1.default.createElement(core_1.TableBody, null, new Array(numberOfRows).fill({}).map((_, index) => (react_1.default.createElement(core_1.TableRow, { key: index },
        react_1.default.createElement(core_1.TableCell, { className: classes.slimmerRow, width: exports.ROW_ACTION_SKELETON_WIDTH * rowActions },
            react_1.default.createElement("div", { className: classes.emptyStateContainer },
                react_1.default.createElement(lab_1.Skeleton, { animation: "pulse" }))),
        react_1.default.createElement(TableLoadingRow_1.TableLoadingRow, { columns: columns }))))));
};
exports.TableLoadingState = TableLoadingState;
//# sourceMappingURL=TableLoadingState.js.map