"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableEditCell = void 0;
const core_1 = require("@material-ui/core");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importDefault(require("react"));
const styles_1 = require("../TableRow/styles");
const TableInputCell_1 = require("./TableInputCell");
const TableLookupCell_1 = require("./TableLookupCell");
const TableEditCell = ({ column, tableStatus, setTableStatus, row, setRow, onChange, }) => {
    var _a, _b;
    const classes = (0, styles_1.useTableRowStyles)();
    const { field } = column;
    const isLookup = (column === null || column === void 0 ? void 0 : column.lookup) || (column === null || column === void 0 ? void 0 : column.lookupAction);
    const value = (row === null || row === void 0 ? void 0 : row[field]) || "";
    const hasError = !!((_a = tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.errors) === null || _a === void 0 ? void 0 : _a[field]);
    const errorMessage = ((_b = tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.errors) === null || _b === void 0 ? void 0 : _b[field]) || "";
    const clearError = () => {
        var _a;
        if ((_a = tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.errors) === null || _a === void 0 ? void 0 : _a[field]) {
            const errors = tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.errors;
            errors === null || errors === void 0 ? true : delete errors[field];
            setTableStatus === null || setTableStatus === void 0 ? void 0 : setTableStatus({ errors });
        }
    };
    const props = {
        column,
        value,
        row,
        setRow,
        clearError,
        hasError,
        errorMessage,
        field,
        onChange,
        tableStatus,
        setTableStatus,
    };
    return (react_1.default.createElement(core_1.TableCell, { onClick: (event) => event.stopPropagation(), className: (0, classnames_1.default)(classes.slimmerRow, {
            [classes.checkbox]: column.type === "checkbox",
        }) }, isLookup ? (react_1.default.createElement(TableLookupCell_1.TableLookupCell, Object.assign({}, props))) : (react_1.default.createElement(TableInputCell_1.TableInputCell, Object.assign({}, props)))));
};
exports.TableEditCell = TableEditCell;
//# sourceMappingURL=TableEditCell.js.map