"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableLookupCell = void 0;
const core_1 = require("@material-ui/core");
const ArrowDropDown_1 = __importDefault(require("@material-ui/icons/ArrowDropDown"));
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const DialogSelect_1 = require("../../DialogSelect/DialogSelect");
const styles_1 = require("../styles");
const TableLookupCell = ({ column, clearError, setRow, value, hasError, errorMessage, field, onChange, row, }) => {
    var _a, _b, _c;
    const [totalItems, setTotalItems] = (0, react_1.useState)();
    const classes = (0, styles_1.useStyle)({});
    const valueLabel = (_c = (_b = (Array.isArray(column.lookup) ? column.lookup : (_a = column.lookup) === null || _a === void 0 ? void 0 : _a.call(column, row))) === null || _b === void 0 ? void 0 : _b.find((option) => option.id === value)) === null || _c === void 0 ? void 0 : _c.label;
    const handleAsyncLookup = (search, limit, page) => __awaiter(void 0, void 0, void 0, function* () {
        var _d;
        const { items, meta } = (yield ((_d = column === null || column === void 0 ? void 0 : column.lookupAction) === null || _d === void 0 ? void 0 : _d.call(column, { search, page, limit }, row))) || { items: [] };
        setTotalItems(meta === null || meta === void 0 ? void 0 : meta.totalItems);
        return (items || []).map((value) => {
            if (typeof value === "string") {
                return { id: value, label: value };
            }
            if (value === null || value === void 0 ? void 0 : value.value) {
                return {
                    id: value.id,
                    value: { id: value.id, name: value.label },
                    label: value.label,
                    secondary: value === null || value === void 0 ? void 0 : value.secondary,
                    source: value.source,
                };
            }
            return {
                id: value.id,
                label: value.label,
                secondary: value === null || value === void 0 ? void 0 : value.secondary,
                source: value.source,
            };
        });
    });
    const handleLookup = (search) => {
        var _a, _b;
        return ((_b = (Array.isArray(column.lookup)
            ? column.lookup
            : (_a = column.lookup) === null || _a === void 0 ? void 0 : _a.call(column, row))) === null || _b === void 0 ? void 0 : _b.filter((value) => {
            var _a;
            return search
                ? (_a = value.label) === null || _a === void 0 ? void 0 : _a.toLocaleLowerCase().includes(search.toLocaleLowerCase())
                : true;
        })) || [];
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(DialogSelect_1.DialogSelect, { value: value, InputComponent: ({ value, onOpen }) => (react_1.default.createElement(core_1.Button, { className: (0, classnames_1.default)(classes.editCell, "MuiInput-underline"), onClick: onOpen, endIcon: react_1.default.createElement(ArrowDropDown_1.default, null) },
                react_1.default.createElement(core_1.Typography, null, valueLabel || value || column.label))), onChange: (newValue, option) => {
                clearError();
                if (onChange) {
                    onChange((newValue || ""), setRow, option);
                }
                else {
                    setRow === null || setRow === void 0 ? void 0 : setRow((prevState) => (Object.assign(Object.assign({}, prevState), { [field]: newValue })));
                }
            }, getOptions: (search, limit, page) => {
                if (column === null || column === void 0 ? void 0 : column.lookupAction) {
                    return handleAsyncLookup(search, limit, page);
                }
                return handleLookup(search);
            }, allowMulti: column.allowMultiSelect, closeOnSelect: !column.allowMultiSelect, loadOptionsByDefault: !column.infiniteScroll, infiniteScroll: !!column.infiniteScroll, totalItems: column.infiniteScroll && column.lookupAction ? totalItems : undefined }),
        react_1.default.createElement(core_1.FormHelperText, { error: hasError, color: "error", component: "p" }, errorMessage)));
};
exports.TableLookupCell = TableLookupCell;
//# sourceMappingURL=TableLookupCell.js.map