"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableAddRow = void 0;
const core_1 = require("@material-ui/core");
const react_1 = __importStar(require("react"));
const getDefaultRowValues_1 = require("../../../helpers/getDefaultRowValues");
const styles_1 = require("../styles");
const TableConfirmActions_1 = require("../TableActions/TableConfirmActions");
const TableEditCell_1 = require("../TableRenderCell/TableEditCell");
const TableRenderCell_1 = require("../TableRenderCell/TableRenderCell");
const TableLoadingRow_1 = require("./TableLoadingRow");
const TableAddRow = ({ columns, actions, actionsNotification, tableStatus, setTableStatus, }) => {
    const classes = (0, styles_1.useStyle)({});
    const [newRow, setNewRow] = (0, react_1.useState)((0, getDefaultRowValues_1.getDefaultRowValues)(columns));
    return (react_1.default.createElement(core_1.TableRow, null, (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.loading) ? (react_1.default.createElement(TableLoadingRow_1.TableLoadingRow, { columns: columns })) : (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.TableCell, { className: classes.actionCell },
            react_1.default.createElement(TableConfirmActions_1.TableConfirmActions, { row: newRow, setRow: setNewRow, notify: actionsNotification, newRow: newRow, actions: actions, tableStatus: tableStatus, setTableStatus: setTableStatus })),
        columns.map((column, cellIndex) => {
            const editable = typeof column.editable === "function"
                ? column.editable(newRow)
                : column.editable;
            const isInputCell = !column.editable || editable === "always";
            if (column.editModifier) {
                return (react_1.default.createElement(react_1.Fragment, { key: cellIndex }, column.editModifier({
                    column,
                    setTableStatus,
                    tableStatus,
                    setRow: setNewRow,
                    row: newRow,
                })));
            }
            return isInputCell ? (react_1.default.createElement(TableEditCell_1.TableEditCell, { key: cellIndex, row: newRow, column: column, setRow: setNewRow, tableStatus: tableStatus, setTableStatus: setTableStatus })) : (react_1.default.createElement(TableRenderCell_1.TableRenderCell, { key: cellIndex, row: newRow, column: column, editMode: true }));
        })))));
};
exports.TableAddRow = TableAddRow;
//# sourceMappingURL=TableAddRow.js.map