"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableEditRow = void 0;
const react_1 = __importStar(require("react"));
const TableEditCell_1 = require("../TableRenderCell/TableEditCell");
const TableRenderCell_1 = require("../TableRenderCell/TableRenderCell");
const TableLoadingRow_1 = require("./TableLoadingRow");
const TableEditRow = ({ columns, tableStatus, setTableStatus, row, setRow, }) => {
    if (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.loading) {
        return react_1.default.createElement(TableLoadingRow_1.TableLoadingRow, { columns: columns });
    }
    return (react_1.default.createElement(react_1.default.Fragment, null, columns.map((column, cellIndex) => {
        const editable = typeof column.editable === "function"
            ? column.editable(row)
            : column.editable;
        const isInputCell = !column.editable || editable === "onEdit" || editable === "always";
        if (column.editModifier) {
            return (react_1.default.createElement(react_1.Fragment, { key: cellIndex }, column.editModifier({
                column,
                setTableStatus,
                tableStatus,
                setRow,
                row,
            })));
        }
        return isInputCell ? (react_1.default.createElement(TableEditCell_1.TableEditCell, { key: cellIndex, row: row, column: column, setRow: setRow, tableStatus: tableStatus, setTableStatus: setTableStatus })) : (react_1.default.createElement(TableRenderCell_1.TableRenderCell, { key: cellIndex, row: row, column: column, editMode: true }));
    })));
};
exports.TableEditRow = TableEditRow;
//# sourceMappingURL=TableEditRow.js.map