"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableRow = void 0;
const core_1 = require("@material-ui/core");
const classnames_1 = __importDefault(require("classnames"));
const react_1 = __importStar(require("react"));
const getDefaultRowValues_1 = require("../../../helpers/getDefaultRowValues");
const TableActions_1 = require("../TableActions/TableActions");
const TableRenderCell_1 = require("../TableRenderCell/TableRenderCell");
const types_1 = require("../types");
const styles_1 = require("./styles");
const TableDeleteRow_1 = require("./TableDeleteRow");
const TableEditRow_1 = require("./TableEditRow");
const TableRow = ({ row, columns, tableStatus, selectKey, hasActions, selectedRows, actions, onRowClick, setTableStatus, hoverableTableRow, actionsNotification, isDisabled, collapsableRows = false, ExpandableRowContent, isHighlighted, }) => {
    const classes = (0, styles_1.useTableRowStyles)();
    const [newRow, setNewRow] = (0, react_1.useState)((0, getDefaultRowValues_1.getDefaultRowValues)(columns));
    const [expanded, setExpanded] = (0, react_1.useState)(false);
    const [actionableRow, setActionableRow] = (0, react_1.useState)(false);
    const isDisabledRow = (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode)
        ? (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.activeRow) !== row[selectKey]
        : false;
    const isEditMode = (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode) === types_1.TableMode.EDIT;
    const isDeleteMode = (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode) === types_1.TableMode.DELETE;
    const isSelectedRow = (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.activeRow) === row[selectKey] && row[selectKey] !== undefined;
    const tableRowClasses = (0, classnames_1.default)(row.className ? row.className : "", {
        [classes.clickableRow]: !!onRowClick,
        [classes.disabledRow]: isDisabledRow,
        [classes.highlightedRow]: isHighlighted
            ? isHighlighted(row) && !isDisabledRow
            : false,
        [classes.actionableRow]: actionableRow,
    });
    const DisplayMode = () => (react_1.default.createElement(react_1.default.Fragment, null, columns.map((column, cellIndex) => (react_1.default.createElement(TableRenderCell_1.TableRenderCell, { key: cellIndex, column: column, row: row })))));
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(core_1.TableRow, { hover: (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode) ? false : hoverableTableRow, selected: selectedRows.includes(row[selectKey]), className: tableRowClasses, onClick: (e) => {
                if (e.currentTarget.contains(e.target)) {
                    setExpanded((expanded) => !expanded);
                    onRowClick === null || onRowClick === void 0 ? void 0 : onRowClick(row, e);
                }
            } },
            hasActions && (react_1.default.createElement(TableActions_1.TableActions, { row: row, newRow: newRow, setNewRow: setNewRow, actions: actions, tableStatus: tableStatus, setTableStatus: setTableStatus, selectKey: selectKey, disabled: isDisabled ? !!isDisabled(row) : false, actionsNotification: actionsNotification, setActionableRow: setActionableRow })),
            isSelectedRow ? (react_1.default.createElement(react_1.default.Fragment, null,
                isEditMode && (react_1.default.createElement(TableEditRow_1.TableEditRow, { columns: columns, tableStatus: tableStatus, setTableStatus: setTableStatus, row: newRow, setRow: setNewRow })),
                isDeleteMode && (react_1.default.createElement(TableDeleteRow_1.TableDeleteRow, { tableStatus: tableStatus, columns: columns })))) : (react_1.default.createElement(DisplayMode, null))),
        collapsableRows && !!ExpandableRowContent && (react_1.default.createElement(core_1.TableRow, null,
            react_1.default.createElement(core_1.TableCell, { colSpan: columns.length + 1, className: (0, classnames_1.default)(classes.collapsableCell, {
                    [classes.borderBottom]: expanded,
                }) },
                react_1.default.createElement(core_1.Collapse, { in: expanded, timeout: "auto", unmountOnExit: true },
                    react_1.default.createElement(ExpandableRowContent, { row: row, columns: columns })))))));
};
exports.TableRow = TableRow;
//# sourceMappingURL=TableRow.js.map