"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStyle = void 0;
const styles_1 = require("@material-ui/core/styles");
exports.useStyle = (0, styles_1.makeStyles)((theme) => (0, styles_1.createStyles)({
    tableWrapper: {
        display: "flex",
        flexDirection: "column",
        flexGrow: 1,
        overflow: "hidden",
    },
    root: {
        borderRadius: ({ border }) => (border ? theme.shape.borderRadius : 0),
        height: "100%",
        paddingBottom: ({ hiddenHeader }) => hiddenHeader ? theme.spacing(0) : theme.spacing(1),
        overflow: "overlay",
    },
    table: {
        minWidth: 650,
    },
    tableHeadCell: {
        lineHeight: ({ hiddenHeader }) => (hiddenHeader ? 0 : "2rem"),
        minWidth: 100,
        border: ({ hiddenHeader }) => (hiddenHeader ? "none" : undefined),
        padding: ({ hiddenHeader }) => hiddenHeader ? theme.spacing(0, 0.5) : theme.spacing(2, 0.5),
        "& :first-child + span": {
            paddingLeft: ({ customStyle }) => customStyle ? theme.spacing(1) : "inherit",
        },
        "& > span": {
            height: ({ hiddenHeader }) => (hiddenHeader ? 0 : undefined),
        },
    },
    resizableWrapper: {
        "&:hover": {
            borderRight: `1px solid ${theme.palette.grey[700]}`,
        },
        "& > span": {
            height: ({ hiddenHeader }) => (hiddenHeader ? 0 : undefined),
        },
    },
    tableActionWrapper: {
        display: "flex",
        justifyContent: "space-between",
    },
    tableActionCell: {
        maxWidth: "100px",
        lineHeight: "2rem",
        padding: theme.spacing(0.25, 1),
    },
    filterRowCell: {
        padding: theme.spacing(0.5, 0.5),
        paddingLeft: ({ customStyle }) => (customStyle ? theme.spacing(1) : 0),
    },
    MuiTableCell: {
        borderBottom: "none",
    },
    emptyCell: {
        padding: theme.spacing(0),
    },
    tableBody: {
        overflow: "auto",
    },
    editCell: {
        width: "100%",
        padding: theme.spacing(0.5),
        justifyContent: "space-between",
        textTransform: "none",
    },
    tableFooter: {
        display: "flex",
        flexDirection: "row",
        justifyContent: "space-between",
        alignItems: "center",
        marginTop: 0,
    },
    pagination: {
        boxShadow: "none",
        padding: "16px",
    },
    actionCell: {
        padding: theme.spacing(0.25, 1),
        overflow: "hidden",
        whiteSpace: "nowrap",
    },
    addButton: {
        border: `2px solid ${theme.palette.secondary.main}`,
        "&:disabled": {
            border: `2px solid ${theme.palette.grey[400]}`,
        },
    },
    inputLabel: {
        "&::placeholder": {
            fontSize: theme.typography.subtitle2.fontSize,
        },
    },
    tableHead: {
        visibility: ({ hiddenHeader }) => (hiddenHeader ? "hidden" : "visible"),
    },
}), { index: 1 });
//# sourceMappingURL=styles.js.map