"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getColumnDefaultValue = exports.getDefaultRowValues = void 0;
const getDefaultRowValues = (columns) => {
    const row = {};
    columns.forEach((column) => {
        if (column.field) {
            const value = (0, exports.getColumnDefaultValue)(column);
            if (value !== undefined)
                row[column.field] = value;
        }
    });
    return row;
};
exports.getDefaultRowValues = getDefaultRowValues;
const getColumnDefaultValue = (column) => {
    if (Object.prototype.hasOwnProperty.call(column, "defaultValue")) {
        return column.defaultValue;
    }
    switch (column.type) {
        case "text":
        case undefined:
            return "";
    }
};
exports.getColumnDefaultValue = getColumnDefaultValue;
//# sourceMappingURL=getDefaultRowValues.js.map