import { Button as ButtonInput } from "@material-ui/core";
import classNames from "classnames";
import React from "react";
import { AUTO } from "../../constants/colors";
import { DEFAULT_BUTTON_ICON_SIZE, DEFAULT_CURSOR, } from "../../constants/defaultLayouts";
import { Icon } from "../Icon";
import { useStyle } from "./styles";
import { ButtonTypes, ButtonVariantTypes } from "./types/buttonTypes";
export const Button = ({ className, name, id, type = ButtonTypes.BUTTON, variant = ButtonVariantTypes.TEXT, text = "", icon, iconSize = DEFAULT_BUTTON_ICON_SIZE, withBeforeIcon = false, withEndIcon = false, padding, margin, outline, border, width, height, maxWidth = AUTO, maxHeight = AUTO, backgroundColor, textColor, hoverBackgroundColor, hoverTextColor, disabledBackgroundColor, disabledTextColor, borderRadius, cursor = DEFAULT_CURSOR, disabled = false, onClick, onFocus, onBlur, }) => {
    const classes = useStyle({
        padding,
        margin,
        outline,
        border,
        width,
        maxWidth,
        maxHeight,
        height,
        backgroundColor,
        textColor,
        borderRadius,
        cursor,
        hoverBackgroundColor,
        hoverTextColor,
        disabledBackgroundColor,
        disabledTextColor,
    });
    return (React.createElement(ButtonInput, { type: type, variant: variant, className: classNames(classes.root, className), id: id, name: name, disabled: disabled, onClick: onClick, onFocus: onFocus, onBlur: onBlur, startIcon: withBeforeIcon &&
            (typeof icon === "string" ? (React.createElement(Icon, { src: icon, width: iconSize, height: iconSize })) : (icon)), endIcon: withEndIcon &&
            (typeof icon === "string" ? (React.createElement(Icon, { src: icon, width: iconSize, height: iconSize })) : (icon)) },
        React.createElement("span", null, text)));
};
//# sourceMappingURL=Button.js.map