/// <reference types="react" />
import { CursorType } from "../../../types/cursorTypes";
import { ButtonTypes, ButtonVariantTypes } from "./buttonTypes";
export interface ButtonProps {
    className?: string;
    name?: string;
    id?: string;
    type?: ButtonTypes;
    variant?: ButtonVariantTypes;
    text?: string;
    icon?: string | JSX.Element;
    iconSize?: string;
    withBeforeIcon?: boolean;
    withEndIcon?: boolean;
    disabled?: boolean;
    padding?: string;
    margin?: string;
    outline?: string;
    border?: string;
    width?: string;
    maxWidth?: string;
    maxHeight?: string;
    height?: string;
    backgroundColor?: string;
    textColor?: string;
    hoverBackgroundColor?: string;
    hoverTextColor?: string;
    disabledBackgroundColor?: string;
    disabledTextColor?: string;
    borderRadius?: string;
    cursor?: CursorType;
    onClick: (...args: any[]) => void;
    onFocus?: (...args: any[]) => void;
    onBlur?: (...args: any[]) => void;
}
export interface ButtonInputProps {
    padding?: string;
    margin?: string;
    outline?: string;
    border?: string;
    width?: string;
    maxWidth?: string;
    maxHeight?: string;
    height?: string;
    backgroundColor?: string;
    textColor?: string;
    hoverBackgroundColor?: string;
    hoverTextColor?: string;
    disabledBackgroundColor?: string;
    disabledTextColor?: string;
    borderRadius?: string;
    cursor?: CursorType;
}
