import { ReactElement } from "react";
import { CursorType } from "../../../types/cursorTypes";
export interface CardProps {
    className?: string;
    id?: string;
    headerTitle?: string;
    footerTitle?: string;
    children: ReactElement;
    maxWidth?: string;
    width?: string;
    height?: string;
    maxHeight?: string;
    padding?: string;
    margin?: string;
    outline?: string;
    border?: string;
    hoverBorder?: string;
    boxShadow?: string;
    borderRadius?: string;
    backgroundColor?: string;
    textColor?: string;
    hoverBackground?: string;
    hoverTextColor?: string;
    cursor?: CursorType;
    onClick: (...args: any[]) => void;
    onFocus?: (...args: any[]) => void;
    onBlur?: (...args: any[]) => void;
    headerContent?: ReactElement;
    headerButton?: ReactElement;
    footerButton?: ReactElement;
    footerContent?: ReactElement;
}
export interface CardStyleProps {
    padding?: string;
    margin?: string;
    outline?: string;
    boxShadow?: string;
    border?: string;
    hoverBorder?: string;
    maxWidth?: string;
    width?: string;
    height?: string;
    maxHeight?: string;
    backgroundColor?: string;
    textColor?: string;
    hoverBackground?: string;
    hoverTextColor?: string;
    borderRadius?: string;
    cursor?: string;
}
export interface HeaderFooterProps {
    withContent?: boolean;
    withTitle?: boolean;
    withButton?: boolean;
}
