import styled from "styled-components";
export const Container = styled.div `
  display: flex;
  flex-direction: column;
  align-items: center;
  margin: ${({ margin }) => margin};
  padding: ${({ padding }) => padding};
  width: ${({ width }) => width};
  height: ${({ height }) => height};
  background-color: ${({ backgroundColor }) => backgroundColor};
  color: ${({ textColor }) => textColor};
  cursor: ${({ cursor }) => cursor};
  position: relative;
`;
export const LabelContainer = styled.div `
  display: flex;
  justify-content: flex-start;
  width: 100%;
  background-color: ${({ backgroundColor }) => backgroundColor};
  color: ${({ textColor }) => textColor};
`;
export const Label = styled.span ``;
export const DropdownContainer = styled.div `
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
  width: 100%;
`;
export const SelectedValue = styled.input `
  background-color: transparent;
  border: 1px solid rgba(0, 0, 0, 0);
  border-bottom: 1px solid ${({ textColor }) => textColor};
  width: 100%;
  cursor: ${({ cursor }) => cursor};
`;
export const OptionContainer = styled.div `
  width: ${({ width }) => width};
  display: flex;
  flex-direction: column;
  align-items: center;
  position: absolute;
  top: 50px;
  left: 0;
  transition: height 0.3s ease-in-out;
  transition-delay: 0.1s;
  height: 0;
  overflow: hidden;

  &.open {
    height: ${({ height }) => height};
    overflow-y: auto;
  }
`;
export const Option = styled.div `
  display: flex;
  justify-content: center;
  align-items: center;
  margin: ${({ margin }) => margin};
  padding: ${({ padding }) => padding};
  width: ${({ width }) => width};
  height: ${({ height }) => height};
  &:hover {
    background-color: ${({ hoverBackgroundColor }) => hoverBackgroundColor};
    color: ${({ hoverTextColor }) => hoverTextColor};
  }

  &.selected {
    background-color: ${({ backgroundColor }) => backgroundColor};
  }
`;
//# sourceMappingURL=styles.js.map