/// <reference types="react" />
import { CursorType } from "../../types/cursorTypes";
export declare type OptionKey = string | number;
export interface DropdownOption {
    key: OptionKey;
    content: string;
}
export interface DropdownProps {
    id?: string;
    className?: string;
    name?: string;
    options?: DropdownOption[] | JSX.Element[];
    withCustomOption?: boolean;
    selectedValue?: string | JSX.Element;
    controlled?: boolean;
    containerMargin?: string;
    containerPadding?: string;
    containerWidth?: string;
    containerHeight?: string;
    optionMargin?: string;
    optionPadding?: string;
    optionWidth?: string;
    optionHeight?: string;
    optionsContainerWidth?: string;
    optionsContainerHeight?: string;
    withArrow?: boolean;
    labelText?: string;
    labelBackgroundColor?: string;
    labelTextColor?: string;
    backgroundColor?: string;
    textColor?: string;
    selectedOptionBackgroundColor?: string;
    hoverOptionBackgroundColor?: string;
    hoverOptionTextColor?: string;
    cursor?: CursorType;
    withCustomSelectedValue?: boolean;
    onChange?: (key: OptionKey) => void;
    onFocus?: (...args: any[]) => void;
    onBlur?: (...args: any[]) => void;
}
export interface ContainerProps {
    margin: string;
    padding: string;
    width: string;
    height: string;
    backgroundColor: string;
    textColor: string;
    cursor: CursorType;
}
export interface LabelContainerProps {
    backgroundColor: string;
    textColor: string;
}
export interface SelectedValueProps {
    textColor?: string;
    cursor: CursorType;
}
export interface OptionProps {
    margin: string;
    padding: string;
    width: string;
    height: string;
    hoverBackgroundColor: string;
    hoverTextColor: string;
    backgroundColor: string;
}
export interface OptionsContainerProps {
    width: string;
    height: string;
}
