import MuiIconButton from "@material-ui/core/IconButton";
import classNames from "classnames";
import React from "react";
import { AUTO } from "../../constants/colors";
import { CursorType } from "../../types/cursorTypes";
import { ButtonTypes } from "../Button";
import { useStyle } from "./styles";
export const IconButton = ({ className, id, name, type = ButtonTypes.BUTTON, children, padding, margin, outline, border, borderRadius, width = AUTO, height = AUTO, maxWidth = AUTO, maxHeight = AUTO, backgroundColor, textColor, hoverBackgroundColor, hoverTextColor, cursor = CursorType.POINTER, disabled = false, title, onClick, onFocus, onBlur, }) => {
    const classes = useStyle({
        padding,
        margin,
        outline,
        border,
        borderRadius,
        width,
        height,
        maxWidth,
        maxHeight,
        backgroundColor,
        textColor,
        cursor,
        hoverBackgroundColor,
        hoverTextColor,
    });
    return (React.createElement(MuiIconButton, { className: classNames(classes.root, className), id: id, name: name, type: type, disabled: disabled, onClick: onClick, onFocus: onFocus, onBlur: onBlur, title: title }, children));
};
//# sourceMappingURL=IconButton.js.map