import { Checkbox, FormControlLabel } from "@material-ui/core";
import classNames from "classnames";
import React from "react";
import { Icon } from "../../Icon";
import { useStyle } from "../styles";
export const CheckboxInput = ({ id, name, className, value, padding, margin, required, autoFocus, disabled, onChange, onFocus, onBlur, icon, iconSize, checked, labelText, textColor, }) => {
    const classes = useStyle({
        padding,
        margin,
        textColor,
    });
    return (React.createElement(React.Fragment, null,
        React.createElement(FormControlLabel, { control: React.createElement(Checkbox, { id: id, name: name, className: classNames(classes.textColor, className), value: value, required: required, 
                // eslint-disable-next-line jsx-a11y/no-autofocus
                autoFocus: autoFocus, disabled: disabled, onChange: onChange, onFocus: onFocus, onBlur: onBlur, checked: checked, 
                //icon={/* some icon component for non checked state */}
                checkedIcon: icon &&
                    (typeof icon === "string" ? (React.createElement(Icon, { src: icon, width: iconSize, height: iconSize })) : (icon)) }), label: labelText })));
};
//# sourceMappingURL=CheckboxInput.js.map