import { Button } from "@material-ui/core";
import classNames from "classnames";
import React from "react";
import { FileHelperText, useStyle } from "../styles";
export const FileInput = ({ className, name, id, padding, margin, required, disabled, onChange, onFocus, onBlur, error, errorBackgroundColor, errorTextColor, helperTextBackgroundColor, helperTextTextColor, textColor, labelText, helperText, icon, }) => {
    const classes = useStyle({
        padding,
        margin,
        errorBackgroundColor,
        errorTextColor,
        helperTextBackgroundColor,
        helperTextTextColor,
        textColor,
        icon,
    });
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { className: classNames(classes.root, className), id: id, variant: "contained", component: "label", disabled: disabled, onFocus: onFocus, onBlur: onBlur },
            icon ? icon : labelText,
            React.createElement("input", { type: "file", name: name, hidden: true, required: required, disabled: disabled, onChange: onChange })),
        (error || helperText) && (React.createElement(FileHelperText, { error: !!error, helperText: !!helperText, errorBackgroundColor: errorBackgroundColor, errorTextColor: errorTextColor, helperTextBackgroundColor: helperTextBackgroundColor, helperTextTextColor: helperTextTextColor }, error ? error : helperText))));
};
//# sourceMappingURL=FileInput.js.map