import TextField from "@material-ui/core/TextField";
import classNames from "classnames";
import React from "react";
import { useStyle } from "../styles";
export const NumberInput = ({ className, id, name, type, value, padding, margin, required, autoFocus, disabled, onChange, onFocus, onBlur, placeholder, error, errorBackgroundColor, errorTextColor, helperTextBackgroundColor, helperTextTextColor, textColor, labelText, helperText, defaultValue, }) => {
    const classes = useStyle({
        padding,
        margin,
        errorBackgroundColor,
        errorTextColor,
        textColor,
        helperTextBackgroundColor,
        helperTextTextColor,
    });
    return (React.createElement(TextField, { id: id, name: name, className: classNames(classes.root, className), type: type, value: value, required: required, 
        // eslint-disable-next-line jsx-a11y/no-autofocus
        autoFocus: autoFocus, disabled: disabled, onChange: onChange, onFocus: onFocus, onBlur: onBlur, placeholder: placeholder, error: !!error, label: labelText, helperText: error ? error : helperText, defaultValue: defaultValue, FormHelperTextProps: Object.assign(Object.assign({}, (error && { className: classNames(classes.error) })), (!error &&
            helperText && { className: classNames(classes.helperText) })), InputLabelProps: Object.assign({}, (error && { className: classNames(classes.error) })), InputProps: {
            className: classNames(classes.textColor),
        } }));
};
//# sourceMappingURL=NumberInput.js.map