import { FormControlLabel, RadioGroup } from "@material-ui/core";
import Radio from "@material-ui/core/Radio";
import classNames from "classnames";
import React from "react";
import { useStyle } from "../styles";
export const RadioInput = ({ id, name, className, value, padding, margin, required, labelText, autoFocus, disabled, onChange, onFocus, onBlur, checked, textColor, }) => {
    const classes = useStyle({
        padding,
        margin,
        textColor,
    });
    return (React.createElement(RadioGroup, null,
        React.createElement(FormControlLabel, { label: labelText, control: React.createElement(Radio, { id: id, name: name, className: classNames(classes.textColor, className), value: value, required: required, 
                // eslint-disable-next-line jsx-a11y/no-autofocus
                autoFocus: autoFocus, disabled: disabled, onChange: onChange, onFocus: onFocus, onBlur: onBlur, checked: checked }) })));
};
//# sourceMappingURL=RadioInput.js.map