import { Dialog, AppBar, Toolbar, DialogContent, DialogActions, } from "@material-ui/core";
import React from "react";
import { useModalStyles } from "./styles";
export function Modal({ open, onClose, children, header, footer, disableBackdropClick = false, maxWidth, className, id, maxHeight, width, height, border, borderRadius, outline, backgroundColor, textColor, padding, margin, headerBackgroundColor, headerTextColor, }) {
    const classes = useModalStyles({
        hasFooter: !!footer,
        maxWidth,
        maxHeight,
        width,
        height,
        border,
        borderRadius,
        outline,
        backgroundColor,
        textColor,
        padding,
        margin,
        headerBackgroundColor,
        headerTextColor,
    });
    return (React.createElement(Dialog, { open: open || false, onClose: onClose, classes: { paper: classes.container }, disableBackdropClick: disableBackdropClick, className: className, id: id },
        header && (React.createElement(AppBar, { position: "static", className: classes.headerContainer },
            React.createElement(Toolbar, { className: classes.header }, header))),
        React.createElement(DialogContent, { color: "initial", className: classes.content }, children),
        footer && (React.createElement(DialogActions, { className: classes.actions }, footer))));
}
//# sourceMappingURL=Modal.js.map