import { createStyles, makeStyles } from "@material-ui/core";
export const useModalStyles = makeStyles((theme) => createStyles({
    container: {
        width: ({ width }) => (width ? width : "100%"),
        height: ({ height }) => (height ? height : "100%"),
        maxWidth: ({ maxWidth }) => (maxWidth ? maxWidth : "1000px"),
        maxHeight: ({ maxHeight }) => (maxHeight ? maxHeight : "auto"),
        border: ({ border }) => (border ? border : "none"),
        borderRadius: ({ borderRadius }) => borderRadius ? borderRadius : ".8rem",
        outline: ({ outline }) => (outline ? outline : "none"),
        backgroundColor: ({ backgroundColor }) => backgroundColor ? backgroundColor : "inherit",
        color: ({ textColor }) => (textColor ? textColor : "inherit"),
        margin: ({ margin }) => (margin ? margin : "auto"),
        padding: ({ padding }) => (padding ? padding : "auto"),
    },
    content: {
        display: "flex",
        flexDirection: "column",
        overflow: "overlay",
        padding: theme.spacing(3),
        paddingBottom: ({ hasFooter }) => (hasFooter ? 0 : theme.spacing(3)),
    },
    actions: {
        padding: theme.spacing(3),
        justifyContent: "space-between",
        flexDirection: "row-reverse",
    },
    header: {
        display: "flex",
        justifyContent: "space-between",
    },
    headerContainer: {
        backgroundColor: ({ headerBackgroundColor }) => headerBackgroundColor ? headerBackgroundColor : "inherit",
        color: ({ headerTextColor }) => headerTextColor ? headerTextColor : "inherit",
    },
}));
//# sourceMappingURL=styles.js.map