import { Fade, IconButton } from "@material-ui/core";
import HighlightOffIcon from "@material-ui/icons/HighlightOff";
import { SnackbarProvider } from "notistack";
import React, { useRef } from "react";
import { useSnackbarWrapperStyles } from "./styles";
export const SnackbarWrapper = ({ children, }) => {
    const notistackRef = useRef(null);
    const classes = useSnackbarWrapperStyles();
    const onClickDismiss = (key) => {
        if (notistackRef && notistackRef.current) {
            notistackRef.current.closeSnackbar(key);
        }
    };
    return (React.createElement(SnackbarProvider, { ref: notistackRef, hideIconVariant: true, action: (key) => (React.createElement(IconButton, { onClick: () => onClickDismiss(key) },
            React.createElement(HighlightOffIcon, { className: classes.dismissButton }))), maxSnack: 3, dense: true, anchorOrigin: { vertical: "bottom", horizontal: "right" }, TransitionComponent: Fade, autoHideDuration: 4000 }, children));
};
//# sourceMappingURL=SnackbarWrapper.js.map