import { Typography } from "@material-ui/core";
import React from "react";
import { useDataStateStyles } from "./styles";
export const DataState = ({ messages, image, children, hideErrorHeader = false, }) => {
    const classes = useDataStateStyles();
    return (React.createElement("div", { className: classes.root },
        image,
        React.createElement("div", { className: classes.container },
            !hideErrorHeader && (React.createElement(Typography, { variant: "h4", gutterBottom: true }, messages[0])),
            !!messages[1] && (React.createElement(Typography, { variant: "h6", gutterBottom: true }, messages[1])),
            React.createElement("div", { className: classes.action }, children))));
};
//# sourceMappingURL=DataState.js.map