import { IconButton, Menu, MenuItem } from "@material-ui/core";
import MoreVertIcon from "@material-ui/icons/MoreVert";
import PopupState, { bindTrigger, bindMenu, } from "material-ui-popup-state";
import React from "react";
export const RowPopup = ({ row, actions, className, color, setActionableRow, }) => (React.createElement(PopupState, { variant: "popover", popupId: "select-column" }, (popupState) => {
    setActionableRow === null || setActionableRow === void 0 ? void 0 : setActionableRow(popupState.isOpen);
    return (React.createElement(React.Fragment, null,
        React.createElement(IconButton, Object.assign({ className: className, color: color, disabled: !actions.length, "aria-label": "cancel" }, bindTrigger(popupState), { onClick: (e) => {
                e.stopPropagation();
                bindTrigger(popupState).onClick(e);
            }, size: "small" }),
            React.createElement(MoreVertIcon, null)),
        React.createElement(Menu, Object.assign({}, bindMenu(popupState)), actions.map(({ label, onClick, enabled = true, isPermitted = true }, index) => isPermitted && (React.createElement(MenuItem, { key: index, disabled: !enabled, onClick: (e) => {
                e.stopPropagation();
                if (row) {
                    onClick(row);
                }
                else {
                    onClick({});
                }
                popupState.close();
            } }, label))))));
}));
//# sourceMappingURL=RowPopup.js.map