import { IconButton, TableCell, Tooltip } from "@material-ui/core";
import DeleteIcon from "@material-ui/icons/Delete";
import EditIcon from "@material-ui/icons/Edit";
import React from "react";
import { getActionsCount } from "../../../helpers/getActionsCount";
import { RowPopup } from "../RowPopup/RowPopup";
import { TableMode } from "../types";
import { useTableActionsStyles } from "./styles";
import { ROW_ACTIONS_WIDTH, TableConfirmActions } from "./TableConfirmActions";
export const TableActions = ({ row, newRow, setNewRow, actions, actionsNotification, tableStatus, setTableStatus, selectKey, disabled, setActionableRow, }) => {
    var _a, _b, _c;
    const classes = useTableActionsStyles();
    const isActionDisabled = disabled ||
        ((tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode) ? tableStatus.activeRow !== row[selectKey] : false);
    const { rowActions } = getActionsCount(actions);
    const hideEditAction = (actions === null || actions === void 0 ? void 0 : actions.hideEdit) && actions.hideEdit(row);
    const hideDeleteAction = (actions === null || actions === void 0 ? void 0 : actions.hideDelete) && actions.hideDelete(row);
    const rowIdentifier = row[selectKey];
    const setTableMode = (tableMode) => {
        setNewRow === null || setNewRow === void 0 ? void 0 : setNewRow(row);
        setTableStatus === null || setTableStatus === void 0 ? void 0 : setTableStatus({ activeRow: rowIdentifier, tableMode });
    };
    const validActions = (_b = (_a = actions === null || actions === void 0 ? void 0 : actions.rowActions) === null || _a === void 0 ? void 0 : _a.call(actions, row)) === null || _b === void 0 ? void 0 : _b.some(({ isPermitted }) => isPermitted === true || isPermitted === undefined);
    const confirmActionsEnabled = (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.activeRow) === rowIdentifier && rowIdentifier !== undefined;
    return (React.createElement(TableCell, { className: classes.actionCell, style: { width: rowActions * ROW_ACTIONS_WIDTH } },
        (actions === null || actions === void 0 ? void 0 : actions.rowActions) && validActions && (React.createElement(RowPopup, { row: row, actions: (_c = actions === null || actions === void 0 ? void 0 : actions.rowActions) === null || _c === void 0 ? void 0 : _c.call(actions, row), setActionableRow: setActionableRow })),
        confirmActionsEnabled ? (React.createElement(TableConfirmActions, { setTableStatus: setTableStatus, notify: actionsNotification, tableStatus: tableStatus, row: row, newRow: newRow, actions: actions })) : (React.createElement(React.Fragment, null,
            !hideEditAction && (actions === null || actions === void 0 ? void 0 : actions.onRowEdit) && (React.createElement(Tooltip, { title: "Edit" },
                React.createElement("span", null,
                    React.createElement(IconButton, { size: "small", disabled: isActionDisabled, "aria-label": "edit", onClick: () => setTableMode(TableMode.EDIT) },
                        React.createElement(EditIcon, null))))),
            !hideDeleteAction && (actions === null || actions === void 0 ? void 0 : actions.onRowDelete) && (React.createElement(Tooltip, { title: "Remove" },
                React.createElement("span", null,
                    React.createElement(IconButton, { size: "small", disabled: isActionDisabled, "aria-label": "remove", onClick: () => setTableMode(TableMode.DELETE) },
                        React.createElement(DeleteIcon, null))))),
            hideDeleteAction && (actions === null || actions === void 0 ? void 0 : actions.disableDeleteTooltip) && (React.createElement(Tooltip, { title: actions.disableDeleteTooltip },
                React.createElement("span", null,
                    React.createElement(IconButton, { size: "small", disabled: true, "aria-label": "remove-disabled" },
                        React.createElement(DeleteIcon, null)))))))));
};
//# sourceMappingURL=TableActions.js.map