var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { TableBody as MuiTableBody, Fade } from "@material-ui/core";
import React from "react";
import { useStyle } from "../styles";
import { TableAddRow } from "../TableRow/TableAddRow";
import { TableRow } from "../TableRow/TableRow";
import { TableMode } from "../types";
import { TableColumnFilter } from "./TableColumnFilter";
export const TableBody = (_a) => {
    var { columns, data, customStyle, hidden, border, filters, setTableFilters, actions, tableStatus, isDisabled, setTableStatus, isHighlighted, hiddenHeader = false } = _a, rest = __rest(_a, ["columns", "data", "customStyle", "hidden", "border", "filters", "setTableFilters", "actions", "tableStatus", "isDisabled", "setTableStatus", "isHighlighted", "hiddenHeader"]);
    const classes = useStyle({ border, customStyle });
    const hasActions = [actions === null || actions === void 0 ? void 0 : actions.onRowAdd, actions === null || actions === void 0 ? void 0 : actions.onRowDelete, actions === null || actions === void 0 ? void 0 : actions.rowActions].filter((action) => action).length > 0 || !!(actions === null || actions === void 0 ? void 0 : actions.headerActions);
    const handleFilterUpdate = (e, column, isStartValue = true) => {
        const { field, type } = column;
        const params = {};
        let value = e == null ? "" : e instanceof Date ? e.toISOString() : e.target.value;
        const initialValue = filters === null || filters === void 0 ? void 0 : filters[field];
        if (["date-range", "amount-range", "date-time-tange"].includes(type || "")) {
            let start;
            let end;
            if (initialValue && Array.isArray(initialValue)) {
                [start, end] = initialValue;
            }
            value = isStartValue ? [value, end || ""] : [start || "", value];
        }
        params[field] = value;
        setTableFilters(params);
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(MuiTableBody, null, !hiddenHeader && (React.createElement(TableColumnFilter, { columns: columns, filters: filters || {}, onChange: handleFilterUpdate, classes: classes, hasActions: hasActions }))),
        !hidden && (React.createElement(Fade, { in: true },
            React.createElement(MuiTableBody, { className: classes.tableBody },
                (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.tableMode) === TableMode.ADD && (React.createElement(TableAddRow, { columns: columns, actions: actions, tableStatus: tableStatus, actionsNotification: rest === null || rest === void 0 ? void 0 : rest.actionsNotification, setTableStatus: setTableStatus })),
                data.map((row, index) => (React.createElement(TableRow, Object.assign({ key: index, row: row, hasActions: hasActions, columns: columns, actions: actions, tableStatus: tableStatus, setTableStatus: setTableStatus, isDisabled: isDisabled, isHighlighted: isHighlighted }, rest)))))))));
};
//# sourceMappingURL=TableBody.js.map