import { Grid, TableFooter as MuiTableFooter, TablePagination, } from "@material-ui/core";
import classNames from "classnames";
import React from "react";
import { useStyle } from "../styles";
export const TableFooter = ({ pagination, paginationClassName, limit, page, totalItems, rowsPerPageOptions, setTableStatus, setLimit, setPage, }) => {
    const classes = useStyle({});
    const handleChangePage = (_event, newPage) => {
        setTableStatus === null || setTableStatus === void 0 ? void 0 : setTableStatus({});
        setPage(newPage);
    };
    const handleChangeRowsPerPage = (event) => {
        setLimit(+event.target.value);
    };
    return (React.createElement(MuiTableFooter, null,
        React.createElement(Grid, { item: true, container: true, className: classes.tableFooter, xs: 12, spacing: 2 }, pagination && (React.createElement(Grid, { item: true, xs: 12 },
            React.createElement(TablePagination, { className: classNames(classes.pagination, paginationClassName), rowsPerPageOptions: rowsPerPageOptions, component: "div", count: totalItems || 0, rowsPerPage: limit, page: page, onPageChange: handleChangePage, onRowsPerPageChange: handleChangeRowsPerPage, SelectProps: { inputProps: { id: "rowsPerPage-input" } }, labelRowsPerPage: React.createElement("label", { htmlFor: "rowsPerPage-input" }, "Rows per page:") }))))));
};
//# sourceMappingURL=TableFooter.js.map