import { TableBody, TableCell, TableRow } from "@material-ui/core";
import { Skeleton } from "@material-ui/lab";
import React from "react";
import { getActionsCount } from "../../../helpers/getActionsCount";
import { useTableRowStyles } from "../TableRow/styles";
import { TableLoadingRow } from "../TableRow/TableLoadingRow";
export const ROW_ACTION_SKELETON_WIDTH = 40;
const DEFAULT_NUMBER_OF_ROWS = 5;
export const TableLoadingState = ({ columns, actions, numberOfRows = DEFAULT_NUMBER_OF_ROWS, }) => {
    const { rowActions } = getActionsCount(actions);
    const classes = useTableRowStyles();
    return (React.createElement(TableBody, null, new Array(numberOfRows).fill({}).map((_, index) => (React.createElement(TableRow, { key: index },
        React.createElement(TableCell, { className: classes.slimmerRow, width: ROW_ACTION_SKELETON_WIDTH * rowActions },
            React.createElement("div", { className: classes.emptyStateContainer },
                React.createElement(Skeleton, { animation: "pulse" }))),
        React.createElement(TableLoadingRow, { columns: columns }))))));
};
//# sourceMappingURL=TableLoadingState.js.map