import { TableCell } from "@material-ui/core";
import classNames from "classnames";
import React from "react";
import { useTableRowStyles } from "../TableRow/styles";
import { TableInputCell } from "./TableInputCell";
import { TableLookupCell } from "./TableLookupCell";
export const TableEditCell = ({ column, tableStatus, setTableStatus, row, setRow, onChange, }) => {
    var _a, _b;
    const classes = useTableRowStyles();
    const { field } = column;
    const isLookup = (column === null || column === void 0 ? void 0 : column.lookup) || (column === null || column === void 0 ? void 0 : column.lookupAction);
    const value = (row === null || row === void 0 ? void 0 : row[field]) || "";
    const hasError = !!((_a = tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.errors) === null || _a === void 0 ? void 0 : _a[field]);
    const errorMessage = ((_b = tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.errors) === null || _b === void 0 ? void 0 : _b[field]) || "";
    const clearError = () => {
        var _a;
        if ((_a = tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.errors) === null || _a === void 0 ? void 0 : _a[field]) {
            const errors = tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.errors;
            errors === null || errors === void 0 ? true : delete errors[field];
            setTableStatus === null || setTableStatus === void 0 ? void 0 : setTableStatus({ errors });
        }
    };
    const props = {
        column,
        value,
        row,
        setRow,
        clearError,
        hasError,
        errorMessage,
        field,
        onChange,
        tableStatus,
        setTableStatus,
    };
    return (React.createElement(TableCell, { onClick: (event) => event.stopPropagation(), className: classNames(classes.slimmerRow, {
            [classes.checkbox]: column.type === "checkbox",
        }) }, isLookup ? (React.createElement(TableLookupCell, Object.assign({}, props))) : (React.createElement(TableInputCell, Object.assign({}, props)))));
};
//# sourceMappingURL=TableEditCell.js.map