var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { Button, FormHelperText, Typography } from "@material-ui/core";
import ArrowDropDownIcon from "@material-ui/icons/ArrowDropDown";
import classNames from "classnames";
import React, { useState } from "react";
import { DialogSelect } from "../../DialogSelect/DialogSelect";
import { useStyle } from "../styles";
export const TableLookupCell = ({ column, clearError, setRow, value, hasError, errorMessage, field, onChange, row, }) => {
    var _a, _b, _c;
    const [totalItems, setTotalItems] = useState();
    const classes = useStyle({});
    const valueLabel = (_c = (_b = (Array.isArray(column.lookup) ? column.lookup : (_a = column.lookup) === null || _a === void 0 ? void 0 : _a.call(column, row))) === null || _b === void 0 ? void 0 : _b.find((option) => option.id === value)) === null || _c === void 0 ? void 0 : _c.label;
    const handleAsyncLookup = (search, limit, page) => __awaiter(void 0, void 0, void 0, function* () {
        var _d;
        const { items, meta } = (yield ((_d = column === null || column === void 0 ? void 0 : column.lookupAction) === null || _d === void 0 ? void 0 : _d.call(column, { search, page, limit }, row))) || { items: [] };
        setTotalItems(meta === null || meta === void 0 ? void 0 : meta.totalItems);
        return (items || []).map((value) => {
            if (typeof value === "string") {
                return { id: value, label: value };
            }
            if (value === null || value === void 0 ? void 0 : value.value) {
                return {
                    id: value.id,
                    value: { id: value.id, name: value.label },
                    label: value.label,
                    secondary: value === null || value === void 0 ? void 0 : value.secondary,
                    source: value.source,
                };
            }
            return {
                id: value.id,
                label: value.label,
                secondary: value === null || value === void 0 ? void 0 : value.secondary,
                source: value.source,
            };
        });
    });
    const handleLookup = (search) => {
        var _a, _b;
        return ((_b = (Array.isArray(column.lookup)
            ? column.lookup
            : (_a = column.lookup) === null || _a === void 0 ? void 0 : _a.call(column, row))) === null || _b === void 0 ? void 0 : _b.filter((value) => {
            var _a;
            return search
                ? (_a = value.label) === null || _a === void 0 ? void 0 : _a.toLocaleLowerCase().includes(search.toLocaleLowerCase())
                : true;
        })) || [];
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(DialogSelect, { value: value, InputComponent: ({ value, onOpen }) => (React.createElement(Button, { className: classNames(classes.editCell, "MuiInput-underline"), onClick: onOpen, endIcon: React.createElement(ArrowDropDownIcon, null) },
                React.createElement(Typography, null, valueLabel || value || column.label))), onChange: (newValue, option) => {
                clearError();
                if (onChange) {
                    onChange((newValue || ""), setRow, option);
                }
                else {
                    setRow === null || setRow === void 0 ? void 0 : setRow((prevState) => (Object.assign(Object.assign({}, prevState), { [field]: newValue })));
                }
            }, getOptions: (search, limit, page) => {
                if (column === null || column === void 0 ? void 0 : column.lookupAction) {
                    return handleAsyncLookup(search, limit, page);
                }
                return handleLookup(search);
            }, allowMulti: column.allowMultiSelect, closeOnSelect: !column.allowMultiSelect, loadOptionsByDefault: !column.infiniteScroll, infiniteScroll: !!column.infiniteScroll, totalItems: column.infiniteScroll && column.lookupAction ? totalItems : undefined }),
        React.createElement(FormHelperText, { error: hasError, color: "error", component: "p" }, errorMessage)));
};
//# sourceMappingURL=TableLookupCell.js.map