import { TableCell, TableRow as MuiTableRow } from "@material-ui/core";
import React, { Fragment, useState } from "react";
import { getDefaultRowValues } from "../../../helpers/getDefaultRowValues";
import { useStyle } from "../styles";
import { TableConfirmActions } from "../TableActions/TableConfirmActions";
import { TableEditCell } from "../TableRenderCell/TableEditCell";
import { TableRenderCell } from "../TableRenderCell/TableRenderCell";
import { TableLoadingRow } from "./TableLoadingRow";
export const TableAddRow = ({ columns, actions, actionsNotification, tableStatus, setTableStatus, }) => {
    const classes = useStyle({});
    const [newRow, setNewRow] = useState(getDefaultRowValues(columns));
    return (React.createElement(MuiTableRow, null, (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.loading) ? (React.createElement(TableLoadingRow, { columns: columns })) : (React.createElement(React.Fragment, null,
        React.createElement(TableCell, { className: classes.actionCell },
            React.createElement(TableConfirmActions, { row: newRow, setRow: setNewRow, notify: actionsNotification, newRow: newRow, actions: actions, tableStatus: tableStatus, setTableStatus: setTableStatus })),
        columns.map((column, cellIndex) => {
            const editable = typeof column.editable === "function"
                ? column.editable(newRow)
                : column.editable;
            const isInputCell = !column.editable || editable === "always";
            if (column.editModifier) {
                return (React.createElement(Fragment, { key: cellIndex }, column.editModifier({
                    column,
                    setTableStatus,
                    tableStatus,
                    setRow: setNewRow,
                    row: newRow,
                })));
            }
            return isInputCell ? (React.createElement(TableEditCell, { key: cellIndex, row: newRow, column: column, setRow: setNewRow, tableStatus: tableStatus, setTableStatus: setTableStatus })) : (React.createElement(TableRenderCell, { key: cellIndex, row: newRow, column: column, editMode: true }));
        })))));
};
//# sourceMappingURL=TableAddRow.js.map