import React, { Fragment } from "react";
import { TableEditCell } from "../TableRenderCell/TableEditCell";
import { TableRenderCell } from "../TableRenderCell/TableRenderCell";
import { TableLoadingRow } from "./TableLoadingRow";
export const TableEditRow = ({ columns, tableStatus, setTableStatus, row, setRow, }) => {
    if (tableStatus === null || tableStatus === void 0 ? void 0 : tableStatus.loading) {
        return React.createElement(TableLoadingRow, { columns: columns });
    }
    return (React.createElement(React.Fragment, null, columns.map((column, cellIndex) => {
        const editable = typeof column.editable === "function"
            ? column.editable(row)
            : column.editable;
        const isInputCell = !column.editable || editable === "onEdit" || editable === "always";
        if (column.editModifier) {
            return (React.createElement(Fragment, { key: cellIndex }, column.editModifier({
                column,
                setTableStatus,
                tableStatus,
                setRow,
                row,
            })));
        }
        return isInputCell ? (React.createElement(TableEditCell, { key: cellIndex, row: row, column: column, setRow: setRow, tableStatus: tableStatus, setTableStatus: setTableStatus })) : (React.createElement(TableRenderCell, { key: cellIndex, row: row, column: column, editMode: true }));
    })));
};
//# sourceMappingURL=TableEditRow.js.map