export const getDefaultRowValues = (columns) => {
    const row = {};
    columns.forEach((column) => {
        if (column.field) {
            const value = getColumnDefaultValue(column);
            if (value !== undefined)
                row[column.field] = value;
        }
    });
    return row;
};
export const getColumnDefaultValue = (column) => {
    if (Object.prototype.hasOwnProperty.call(column, "defaultValue")) {
        return column.defaultValue;
    }
    switch (column.type) {
        case "text":
        case undefined:
            return "";
    }
};
//# sourceMappingURL=getDefaultRowValues.js.map